  @echo off
setlocal enabledelayedexpansion enableextensions


	echo =============================================================
	echo %date% %time% - %~dpnx0 [%*]
:CHECKHELP
	set bat_vers=0.979g
	rem set bat_calnstars=50
	rem set bat_caloc=2.50

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	set bat_camerahint=+
	set return=goto :EOF
	set bat_return=goto :EOF
	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_LOG=call :LOG
	set BAT_ECHO=call :ECHOONLY

	set bat_color_on=toggle on

	set bat_exedir=%~dp0::&						rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	set bat_exedrive=!bat_exedir:~0,2!&			rem f:
	
	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		echo     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_caldir=!bat_startlocation!\Cal
	set bat_logfile=!bat_startlocation!\AutoCams.bat.log
	
	set bat_autonomous=
	echo.%*|find /i "autonomous">nul:
	if %errorlevel% equ 0 (
		set bat_autonomous=autonomous
		set bat_precapturedfilesdir=%~1
		set bat_capturedfilesdir=%~1
		set bat_archivedfilesdir=%~2
		set bat_camera=%~3
	)
	
	%bat_echolog% =============================================================
	%bat_echolog% %date% %time% - %~dpnx0 %*
	
	set bat_returncode=0

	set bat_hasrun_post=false
	set bat_hasrun_reprocess=false
	set bat_hasrun_calupdate=false
	set bat_hasrun_cal=false
	set bat_hasrun_confirm=false
	set bat_hasrun_submission=false
	set bat_hasrun_zip=false

	call :READPARAMS
	call :READCONFIG
	call :GETCONFIRMEDCOUNT

	call :PARSEARGS %*
echo ---------bat_archivedfilesdir=!bat_archivedfilesdir!
	if not exist "!bat_mainspec!\!bat_getdirname!" (
		echo     ERROR: specified source dir doesn't exist:^("!bat_mainspec!\!bat_getdirname!"^)
		exit /b 1
	) else (
		echo     bat_mainspec=!bat_mainspec!
	)
	
	if defined bat_autonomous (
		call :AUTOCAMS
		call :SAVECONFIG
		echo.
		echo Done with %0 %*
		echo.
		EXIT
	) else (
		goto :MENU
	)
	
goto :MENU

	
:PARSEARGS
!bat_echolog! call :PARSEARGS %*
!bat_echolog! '     :PARSEARGS %1, %~dp1, %~nx1
	if defined bat_autonomous (
		set bat_getdirname=%~nx2
		set bat_arg1=%~2
	) else (
		set bat_getdirname=%~nx1
		set bat_arg1=%~1
	)
	set bat_mainspec=!bat_startlocation!\ArchivedFiles
	set bat_mainfilter=^|find /i "!bat_getdirname!"
	
	if "!bat_arg1!" neq "" (
		if ":" equ "!bat_arg1:~1,1!" (
			echo     Format: x:\CAMS\ArchivedFiles\date_time
			rem format is: x:\CAMS\ArchivedFiles\2011_08_15_00_00_00
			rem set bat_startdrive=!bat_arg1:~0,2!
			rem set bat_startlocation=!bat_startdrive!\CAMS
			set bat_mainspec=!bat_startlocation!\ArchivedFiles
			set bat_mainfilter=^|find /i "!bat_getdirname!"
		) else (
			rem look for 2011_08_15_00_00_00
			echo     Scanning like this: %~1^|find /i /c "ArchivedFiles\"
			echo     %~1|find /i /c "ArchivedFiles\"
			echo     !errorlevel!
			if !errorlevel! equ 0 (
				echo     Format: ArchivedFiles\!bat_getdirname!
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=^|find /i "!bat_getdirname!"
			) else (
				echo     Format: 2011_08_15_00_00_00
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=|find /i /c "!bat_getdirname!"
			)
		)
	)
!bat_echolog! return-:PARSEARGS [!bat_getdirname!, !bat_mainspec!, !bat_mainfilter!]
%return%



REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================

:MENU
	call :CLEARSCREEN
	color !bat_color!
	if not defined bat_captureddate (
		set bat_titlebar=%~dpnx0 - CAMS MENU Vers !bat_vers!
	) else (
		set bat_titlebar=%~dpnx0 - CAMS MENU Vers !bat_vers!  for Captured Date: !bat_captureddate!
		call :FORMATDATE bat_dateinput !bat_captureddate!
	)
	rem TITLE !bat_titlebar!
	TITLE %~dpnx0 - CAMS MENU
	echo  !bat_titlebar!
	echo.
	echo  1.  Choose target location     !bat_targetlocation!
	echo  2.  Enter Camera               !bat_camera!
	echo  3.  Enter Captured Date        !bat_captureddate!		!bat_capturedtime!
	echo.
	echo  4.  Choose CapturedFiles       [Files=!bat_capturedcount!]	"!bat_capturedfilesdir!" 
	echo  5.    Check Skipped Frames and dropped frames
	echo  6.  Choose ArchivedFiles       [F/Det=!bat_archivedcount!/!bat_archivedmeteorcount!]	"!bat_archivedfilesdir!"
	echo                                 [detect=!bat_detectfile!]
	echo Calibration Options:
	echo  7a. Calibration Update		^(FTP_MeteorCal_Update^)			"!bat_archivedfilesdir!"
	echo  7b. Auto Calibration Update 	^(FTP_MeteorCal_AutoUpdate^)		"!bat_capturedfilesdir!"
	echo  7c. Auto Cal with prompts	^(FTP_MeteorCal_AutoUpdate w/ prompt^)	"!bat_capturedfilesdir!"
	echo  7d. Manual Calibration		^(FTP_MeteorCal^)
	echo.
	echo  9.  Apply Cal to Archived      Current Cal: !bat_latestcal!
	echo.
	echo 10.  FTP_Confirmation           [Count: !bat_confirmedmeteorcount!]	"!bat_confirmedfilesdir!"
	echo 11.    Edit comments.txt file   
	echo 12.    Apply Cal to Confirmed   Confirmed Cal: !bat_confirmedcal!
	echo.
	echo Submission dir functions:       ["!bat_submissionfilesdir!"]
	echo 13.  Package Working dirs into SubmissionFiles dirs
	echo 14.    Choose Submission dir    
	echo 15.    Move SubmissionFiles dirs to working files dirs 
	echo 16.  Zip Submitted dir          !bat_zipfile!
	echo 17.  Upload Zip via FTP (Submit)
	echo 18.  Report on Submission
	echo.
	echo  A.  Autonomous mode           FA. Fix Detect Paths Archived   [FixDetectPaths.bat]
	echo  R.  Reset                     FC. Fix Detect Paths Confirmed  [FixDetectPaths.bat]
	echo  U.  Utility Menu              ClearError. Clear recent error message
	echo  Q.  Quit
	echo                Last error msg: !bat_recent_error_msg!

	
	set bat_choice=none
	set /P bat_choice=Enter choice: 
	echo.
	if /i "!bat_choice!" equ "q" goto :DONE

	call :READPARAMS

	if /i "!bat_choice!" equ "r" (
		CALL :RESET
	)
	if /i "!bat_choice!" equ "u" goto :UTILSMENU
	if /i "!bat_choice!" equ "30" goto :UTILSMENU
	
	if /i "!bat_choice!" equ "1"  call :CHOOSETARGETDRIVE&goto :MENU
	if /i "!bat_choice!" equ "2"  call :CHOOSECAMERA&goto :MENU
	if /i "!bat_choice!" equ "3"  call :CHOOSEDATE&goto :MENU
	if /i "!bat_choice!" equ "3s"  (
		set bat_choice=s
		call :CHOOSEDATESUB&goto :MENU
	)
	
	if /i "!bat_choice!" equ "4"  call :CHOOSECAP&goto :MENU
	if /i "!bat_choice!" equ "5"  call :SKIPPEDFRAMES&GOTO :MENU
	
	if /i "!bat_choice!" equ "6"  call :CHOOSEARCH&goto :MENU
	if /i "!bat_choice!" equ "7a"  call :CALUPDATE&goto :MENU
	if /i "!bat_choice!" equ "7b"  call :CALUPDATEAUTO&goto :MENU
	if /i "!bat_choice!" equ "7c"  call :CALUPDATEAUTOPROMPT&goto :MENU
	if /i "!bat_choice!" equ "7d"  call :CAL&goto :MENU
	if /i "!bat_choice!" equ "9"  call :APPLY&goto :MENU
	if /i "!bat_choice!" equ "10" call :CONFIRM&goto :MENU
	if /i "!bat_choice!" equ "11" call :EDITCOMMENTS&goto :MENU
	if /i "!bat_choice!" equ "12" call :APPLYCONFIRMED&goto :MENU
	if /i "!bat_choice!" equ "13" call :SUBMIT&goto :MENU
	if /i "!bat_choice!" equ "14" call :choosesubmission&goto :MENU
	if /i "!bat_choice!" equ "15" call :RESTORESUBMIT&goto :MENU
	if /i "!bat_choice!" equ "16" call :MAKEZIP&goto :MENU
	if /i "!bat_choice!" equ "17" call :UPLOADFTP&goto :MENU
	if /i "!bat_choice!" equ "18" call :EMAILTEXT&goto :MENU
	
	if /i "!bat_choice!" equ "31" call :CMDPROMPT&goto :MENU
	if /i "!bat_choice!" equ "32" call :CHECKBINFILESIZE&goto :MENU
	if /i "!bat_choice!" equ "33" call :CHECKBINCLEANUP&goto :MENU
	if /i "!bat_choice!" equ "34" call :CHECKFREESPACE&goto :MENU
	if /i "!bat_choice!" equ "35" call :LISTDRIVES&goto :MENU
	if /i "!bat_choice!" equ "36" call :VALIDATECAL&goto :MENU
	if /i "!bat_choice!" equ "37" call :METEORCOUNTPRE&goto :MENU
	if /i "!bat_choice!" equ "38" call :METEORCOUNTSUB&goto :MENU
	if /i "!bat_choice!" equ "39" call :GETFFDIRLIST&goto :MENU
	if /i "!bat_choice!" equ "40" call :GETCAPTURED&goto :MENU
	if /i "!bat_choice!" equ "41" call :GETARCHIVED&goto :MENU
	if /i "!bat_choice!" equ "42" call :GETTWILIGHT&GOTO :MENU
	if /i "!bat_choice!" equ "43" call :LAUNCHCAPTURE&GOTO :MENU
	if /i "!bat_choice!" equ "44"  call :REPROCESSMULTI&goto :MENU
	if /i "!bat_choice!" equ "44b" call :MERGECASE&goto :MENU
	if /i "!bat_choice!" equ "45"  call :REPROCESS&goto :MENU
	if /i "!bat_choice!" equ "45b" call :POSTMULTI "!bat_captureddate!"&goto :MENU
	if /i "!bat_choice!" equ "47" call :DAYOFWEEK&goto :MENU
	if /i "!bat_choice!" equ "48" call :SAVECONFIG&goto :MENU
	if /i "!bat_choice!" equ "49" call :NIGHTMODE&goto :MENU

	if /i "!bat_choice!" equ "50" call :LISTFAILED&goto :MENU
	if /i "!bat_choice!" equ "51" call :LISTUNZIPPED&goto :MENU
	if /i "!bat_choice!" equ "52" call :LISTUNTRANSMITTED&goto :MENU

	if /i "!bat_choice!" equ "53" call :METEORMOVIES&goto :MENU
	if /i "!bat_choice!" equ "54" call :COINCIDENCE&goto :MENU

	if /i "!bat_choice!" equ "55" call :CAMERALIVEVIEWER&goto :MENU
	if /i "!bat_choice!" equ "56" call :SINGLEFFMOVIE&goto :MENU
	if /i "!bat_choice!" equ "57" call :CAMERAMOVIES&goto :MENU
	if /i "!bat_choice!" equ "58" call :MOSAIC&goto :MENU
	if /i "!bat_choice!" equ "59" call :ADJUSTFFTIMESTAMP&goto :MENU
	if /i "!bat_choice!" equ "60" call :CALSUMMARY&goto :MENU
	
	if /i "!bat_choice!" equ "61" call :MAKEARCHIVEDATEZIP&goto :MENU
	

	rem Hidden extras
	if /i "!bat_choice!" equ "v"  call :VARIABLES&goto :MENU
	if /i "!bat_choice!" equ "a"  call :AUTO&goto :MENU
	if /i "!bat_choice!" equ "cls" cls&:goto :MENU
	if /i "!bat_choice!" equ "fa" call :FIXDETECTPATHS "!bat_archivedfilesdir!" !bat_detectfile!&goto :MENU
	if /i "!bat_choice!" equ "fc" call :FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfile!&goto :MENU
	if /i "!bat_choice!" equ "clearerror" call :CLEARERROR&goto :MENU
	if /i "!bat_choice!" equ "edit" call :EDITAUTOCAMS&goto :MENU
	
	if /i "!bat_choice!" equ "?" set bat_&pause&goto :MENU
	echo.!bat_choice!|find /i "notepad "
	if %errorlevel% equ 0 (
		echo %cd%
		start "" !bat_choice!
	)
	
goto :MENU




	rem R. Reset ******************************************
:RESET
	set bat_archdirname=
	set bat_archivedate=
	set bat_archivedcount=
	set bat_archivedfilesdir=
	set bat_archivedmeteorcount=
	set bat_capturedcount=
	set bat_captureddate=
	set bat_capturedfilesdir=
	set bat_capturedtime=
	set bat_confirmeddetect=
	set bat_confirmedfilesdir=
	set bat_confirmedmeteorcount=
	set bat_detectfile=
	set bat_detectfileconf=
	set bat_latestcal=
	set bat_recent_error_msg=
	set bat_submissiondate=
	set bat_submissiondirname=
	set bat_submissionfilesdir=
	set bat_zip=
	set bat_zipfile=
	set bat_recent_error_msg=

	call :SAVECONFIG
%bat_return%


:CLEARERROR
	set bat_recent_error_msg=
%bat_return%


	rem a. AutoCams  ***************************
:AUTO
!bat_echolog! call :AUTO %*
	!bat_echolog! '    call !bat_exedir!\autocams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
					   call !bat_exedir!\autocams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
	call :READCONFIG
!bat_echolog! return-:AUTO [!bat_capturedfilesdir!]
%bat_return%

AUTOCAMS.autonomouslevel=cal
AUTOCAMS.autonomouslevel=apply
AUTOCAMS.autonomouslevel=applyconfirmed
AUTOCAMS.autonomouslevel=submit
AUTOCAMS.autonomouslevel=zip
AUTOCAMS.autonomouslevel=ftp

:AUTOCAMS
echo call :AUTOCAMS %*
	rem This routine performs the following steps:
	set bat_recent_error_msg=

	if /i "!bat_archivedfilesdir:~-14!" equ "ArchivedFiles\" (
		echo.
		set bat_recent_error_msg=ERROR - "!bat_archivedfilesdir!" is missing ArchivedFiles dir name
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
		goto :AUTOCAMS_END
	)

	:AZ_FIXDETECTPATHS
		call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!"
		set bat_retval=!errorlevel!
		if !bat_retval! neq 0 (
			set bat_returncode=!bat_retval!
			set bat_recent_error_msg=ERROR - AZ_FIXDETECTPATHS - Unable to patch paths in detect file
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			call :SAVECONFIG
			goto :AUTOCAMS_END
		) else (
			set bat_recent_error_msg=SUCCESS - AZ_FIXDETECTPATHS - "!bat_archivedfilesdir!"
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			call :SAVECONFIG
		)


	:AZ_CALAUTO
		rem   7b. FTP_MeteorCal_AutoUpdate
		call :CALUPDATEAUTO
		call :SAVECONFIG
		if "!bat_returncode!" neq "0" (
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			goto :AUTOCAMS_END
		)

		if /i "!bat_AUTOCAMS.autonomouslevel!" equ "cal" (goto :AUTOCAMS_END)

	:AZ_APPLYAUTO
		rem   9.  FTP_ApplyCal2detectinfo
		call :APPLYAUTO
		call :SAVECONFIG
		if !bat_returncode! neq 0 (
			set bat_recent_error_msg=ERROR - 9.a. ApplyAuto failed
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			call :SAVECONFIG
			goto :AUTOCAMS_END
		)

		if /i "!bat_AUTOCAMS.autonomouslevel!" equ "apply" (goto :AUTOCAMS_END)

	:AZ_FIXDETECTPATHSCONF
		call :FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfileconf!
		if !errorlevel! neq 0 (
			set bat_recent_error_msg=WARNING - :AZ_FIXDETECTPATHSCONF - Unable to patch paths in detect file [call :FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfileconf!]
			!bat_echolog! '    !bat_recent_error_msg!
		)
		call :SAVECONFIG

	:AZ_APPLYCONFIRMED
		rem   9.  FTP_ApplyCal2detectinfo
		call :APPLYCONFIRMED
		if !bat_returncode! neq 0 (
			set bat_recent_error_msg=NOTICE AZ_APPLYCONFIRMED [%*]- Apply Confirmed failed
			!bat_echolog! '    !bat_recent_error_msg!
		)
		call :SAVECONFIG

		if /i "!bat_AUTOCAMS.autonomouslevel!" equ "applyconfirmed" (goto :AUTOCAMS_END)

	:AC_SUBMITAUTO
		rem  13.  Submission
		call :SUBMITAUTO
		call :SAVECONFIG
		!bat_echolog! bat_returncode=!bat_returncode!
		if /i "!bat_returncode!" neq "0" (
			set bat_recent_error_msg=ERROR - Failed 13.a. Submission [!bat_capturedfilesdir!]
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
			goto :AUTOCAMS_END
		) else (
			set bat_recent_error_msg=SUCCESS - 13.a. Submission [!bat_capturedfilesdir!]
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
		)


		if /i "!bat_AUTOCAMS.autonomouslevel!" equ "submit" (goto :AUTOCAMS_END)

	:AC_MAKEZIPAUTO
		rem  16.  Make Transmit Zip
		call :MAKEZIPAUTO
		call :SAVECONFIG
		if /i "!bat_retval!" neq "success" (goto :AUTOCAMS_END)

		if /i "!bat_AUTOCAMS.autonomouslevel!" equ "zip" (goto :AUTOCAMS_END)

	:AC_FTPAUTO
		rem  17.  Upload Zip
		set bat_retval=
		call :UPLOADFTPAUTO
		call :SAVECONFIG
		if /i "!bat_retval!" neq "success" (goto :AUTOCAMS_END)

		if /i "!bat_AUTOCAMS.autonomouslevel!" equ "ftp" (goto :AUTOCAMS_END)

	:AUTOCAMS_END
	echo return-:AUTOCAMS %*

	Echo .........Waiting !bat_AUTOCAMS.completewait! seconds
	start /w wait !bat_AUTOCAMS.completewait!
%bat_return%



	rem 1. Choose Target Drive  ***************************
:CHOOSETARGETDRIVE
	call ListDrives.bat
	echo.
	echo.
	echo Idealy, the target location is specified as a Drive:
	echo There are cases where the target location is a drive and path
	echo instead.  In that case, enter the Drive and Path without including
	echo the CAMS part.
	echo.
	set bat_choice=
	set /P bat_choice=Enter drive [!bat_targetdrive!]: 
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_targetdrive!)
	set bat_choice=!bat_choice!\\
	set bat_choice=!bat_choice:\\\=!
	set bat_choice=!bat_choice:\\=!
	
		rem Convert "C:\CAMS" to "C:"
	if /i "!bat_choice:~-5!" equ "\CAMS" (
		set bat_choice=!bat_choice:~-5!
	)

	if /i "!bat_choice:~0,2!\CAMS" neq "!bat_exedir!" (
		echo dir "!bat_choice!\CAMS\AutoCams.bat" /b
		     dir "!bat_choice!\CAMS\AutoCams.bat" /b
		if exist "!bat_choice!\CAMS\AutoCams.bat" (
			cd /d "!bat_choice!"
			call :RESET
			set bat_targetdrive=!bat_choice!
			set bat_targetlocation=!bat_choice!
			call :SAVECONFIG
			!bat_echolog! '    "!bat_choice!\CAMS\AutoCams.bat"
			                   "!bat_choice!\CAMS\AutoCams.bat"
		) else (
			echo     ERROR - The cams executables and scripts are not found
			echo             in the new location. You will need to copy them
			echo             to the new location before being able to switch to:
			echo             "!bat_choice!"
		)
	) else (
		call :RESET
		set bat_targetdrive=!bat_choice!
		set bat_targetlocation=!bat_choice!

		call :SAVECONFIG
	)
%bat_return%
	


	rem obsolete subroutine
:ENTERCAMERA
	set /p bat_camera=Enter Camera number: 
	call :SAVECONFIG

%bat_return%



	rem 2. Enter Camera ***********************************
:CHOOSECAMERA
	if not exist "!bat_targetlocation!\CAMS\Cal\CameraSites.txt" (
		echo ERROR - Not Found: "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"
		echo.
	)
	set bat_choice=
	set /P bat_choice=Enter your camera number: 
	if "!bat_choice!" equ "" goto :CAMERA_END
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_camera!)
	
	set bat_temp=!bat_choice!      
	set bat_temp=!bat_temp:~0,6!
	
	find /i "!bat_temp!!bat_camerahint!" "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"
	if !errorlevel! neq 0 (
		echo ERROR - Camera Not Found: !bat_choice! in "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"
		echo.
		pause
		goto :CAMERA_END
	)

	set bat_choice2=
	echo.
	set /P bat_choice2=Do you see your camera in this list? Y/N 
	if /i "!bat_choice2!" neq "y" goto :CAMERA_END

	set bat_camera=!bat_choice!
	call :SAVECONFIG

:CAMERA_END
%bat_return%


	rem Not yet implemented ***************************************
:CHOOSESTATION
	set bat_temp= 
	set /a bat_counter=0
	for /f "usebackq tokens=1-7 skip=2" %%a in (`type "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"^|sort /+63`) do (
		if /i "%%a" equ "Cam#" goto :CHOOSESTATION2
		if /i "%%a" equ "----" goto :CHOOSESTATION2
		if /i "%%f" equ "!bat_temp!" goto :CHOOSESTATION2
		if "!bat_temp!" neq "!bat_siteabbrev!" (
			set bat_counter+=1
			set bat_siteabbrev=%%f
			set bat_temp=!bat_siteabbrev!
			echo %%f  %%g
		)
		
:CHOOSESTATION2		
	)
	
	set bat_choice=
	set /P bat_choice=Enter your site abbreviation (2 characters): 
	
	set bat_temp= 
	set /a bat_counter=0
	for /f "usebackq tokens=1-7 skip=2" %%a in (`type "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"^|sort /+63`) do (
		if /i "%%a" equ "Cam#" goto :CHOOSESTATION2
		if /i "%%a" equ "----" goto :CHOOSESTATION2
		if /i "%%f" equ "!bat_choice!" (
			set bat_counter+=1
			echo %%a  %%b  %%c  %%d  %%e  %%f  %%g
		)
	)
	
	set bat_choice=
	set /P bat_choice=Enter your camera number: 
	set bat_camera=!bat_choice!
%bat_return%



	rem 3. Enter Captured Date  ***********************************
:CHOOSEDATE
	echo.
	echo   Here is a list of CaptureFiles directories:
	echo.
	set bat_found=false
	set /a bat_counter=0
	set bat_usesubmissiondir=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\CapturedFiles" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					rem echo     !bat_counter!.  !bat_targetlocation!\CAMS\CapturedFiles\%%~nxa
					set /a bat_counter+=1
					set bat_temp=%%~nxa
					set bat_tempcameralist=
					set bat_prevcamera=

					REM Need to figure out a way to speed this up
					for /f "usebackq tokens=*" %%b in (`dir "!bat_targetlocation!\CAMS\CapturedFiles\!bat_temp!\FF*.bin" /a-d /b /on`) do (
						set bat_temp2=%%~nxb
						set bat_tempcamera=!bat_temp2:~2,3!
						if /i "!bat_tempcamera!" neq "!bat_prevcamera!" (
							set bat_prevcamera=!bat_tempcamera!
							set bat_tempcameralist=!bat_tempcameralist! !bat_tempcamera!
						)
					)
					echo     !bat_counter!.  !bat_targetlocation!\CAMS\CapturedFiles\%%~nxa   !bat_tempcameralist!
				)
			)
		)
	)

	set bat_choice=
	echo.
	echo Enter the number matching the date to process, [S] to list 
	set /P bat_choice=SubmissionFiles directories, or just enter your own date [mm/dd/yyyy]: 
	if /i "!bat_choice!" equ "" (
		echo     Aborting with "!bat_choice!"
		goto :CHOOSEDATE_END
	)

:CHOOSEDATESUB
	rem ==================================
	if /i "!bat_choice!" NEQ "s" (
		rem You get here when the user enters a date in the format:
		rem   10/21/2012 [american format: mm/dd/yyyy]
		
		echo.

		rem Check for any "/" in the choice string to indicate manual entry of a date
		echo.!bat_choice!|find /i "/">nul:
		if !errorlevel! equ 0 (
			rem A manual date entry was made
			goto :CHOOSEDATE2
		)

		rem You get here if the user selected an entry from the CapturedFiles listing
		if !bat_counter! equ 0 (
			rem You get here when bat_counter=0.  The bat_counter variable is the number of
			rem items listed in the CapturedFiles listing. 
			set bat_choice=
			set /P bat_choice=No CapturedFiles directories found matching "!bat_targetlocation!\CAMS\CapturedFiles". Enter any key to go back to the menu. 
			goto :CHOOSEDATE_END
		)

		
		echo Falls through to listing of SubmissionFiles\...\CapturedFiles matching the selected date: 
		set bat_found=false
		set /a bat_counter=0
		for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\CapturedFiles" /b /ad /on`) do (
			set /a bat_counter+=1
			if "!bat_counter!" equ "!bat_choice!" (
				call :RESET
				set bat_found=true
				set bat_captureddate=%%a
				set bat_capturedtime=!bat_captureddate:~11,8!
				set bat_captureddate=!bat_captureddate:~0,10!
			)
		)
		if /i "!bat_found!" equ "false" goto :CHOOSEDATE_END
		
		goto :CHOOSEDATE3
	) else (
		if /i "!bat_choice!" equ "s" (
			echo     Scanning SubmissionFiles directory...
			set bat_usesubmissiondir=!bat_targetlocation!\CAMS\SubmissionFiles"

			set /a bat_counter=0
			echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on`^) do ...
			for      /f "usebackq tokens=*" %%a in  (`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on`) do (
				set /a bat_counter+=1
				echo !bat_counter!. %%a
			)

			echo.
			if !bat_counter! equ 0 (
				set bat_choice=
				set /P bat_choice=No SubmissionFiles directories found matching !bat_captureddate!. Press any key to skip. 
				goto :CHOOSEDATE_END
			)

			set bat_choice=
			set /P bat_choice=Select the SubmissionFiles directory to work with: 
			if "!bat_choice!" equ "" goto :CHOOSEDATE_END

			set /a bat_counter=0
			set bat_found=false
			echo Listing of SubmissionFiles: 
			for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on`) do (
				set /a bat_counter+=1
				if "!bat_counter!" equ "!bat_choice!" (
					echo "!bat_choice!"
					call :RESET
					set bat_submissionfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\%%a
					set bat_found=true
					set bat_dirname=%%~nxa
					set bat_submissiondirname=%%~nxa
					set bat_Submissiondate=!bat_dirname:~0,10!
					set bat_captureddate=!bat_Submissiondate!
					set bat_capturedtime=!bat_dirname:~11,8!
				)
			)
			if "!bat_found!" neq "" (
				goto :CHOOSESUBMISSION1
			) else (
				goto :CHOOSEDATE_END
			)
		)& end if /i "!bat_choice!" equ "s"...
	)

:CHOOSEDATE2
	rem You can get here with bat_choice containing:
	rem   - A manually entered date [mm/dd/yyyy]
	rem

	echo "!bat_choice!"
	call :RESET
	
	rem Parse a manually entered date
	for /f "delims=/ tokens=1-3" %%a in ("!bat_choice!") do (
		set bat_yyyy=20%%c
		set bat_yyyy=!bat_yyyy:~-4!
		set bat_mm=0%%a
		set bat_mm=!bat_mm:~-2!
		set bat_dd=0%%b
		set bat_dd=!bat_dd:~-2!
	)

	set bat_captureddate=!bat_yyyy!_!bat_mm!_!bat_dd!
:CHOOSEDATE3
	set bat_capturedfilesdir=
	set bat_archivedfilesdir=
	set bat_latestcal=
	set /a bat_capturedcount=0
	set /a bat_archivedcount=0
	call :SAVECONFIG

	call :CHOOSECAP
	call :CHOOSEARCH
:CHOOSEDATE_END
%bat_return%


:CLEARSCREEN
	for /l %%A in (1,1,50) do (echo.)
%bat_return%



	rem 4. Choose CapturedFiles directory *******************
:CHOOSECAP
	rem Choose Captured directory
	echo.
	set /a bat_counter=0

	set bat_finddate=
	if "!bat_captureddate!" neq "" (
		set bat_finddate=\!bat_captureddate!*
	)

	echo    Listing of CapturedFiles:
	echo.
	rem echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetlocation!\CAMS\CapturedFiles!bat_finddate!" /b /ad /on`^) do ^(
	for          /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\CapturedFiles!bat_finddate!" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					rem echo      !bat_counter!. !bat_targetlocation!\CAMS\CapturedFiles\%%~nxa
					set bat_tempfilesdir=!bat_targetlocation!\CAMS\CapturedFiles\%%~nxa
					set bat_tempdirname=%%~nxa

					set bat_temp=%%~nxa
					set bat_tempcameralist=
					set bat_prevcamera=
					for /f "usebackq tokens=*" %%b in (`dir "!bat_targetlocation!\CAMS\CapturedFiles\!bat_temp!\FF*.bin" /a-d /b /on`) do (
						set bat_temp2=%%~nxb
						set bat_tempcamera=!bat_temp2:~2,3!
						if /i "!bat_tempcamera!" neq "!bat_prevcamera!" (
							set bat_prevcamera=!bat_tempcamera!
							set bat_tempcameralist=!bat_tempcameralist! !bat_tempcamera!
						)
					)
					echo     !bat_counter!.  !bat_targetlocation!\CAMS\CapturedFiles\%%~nxa   !bat_tempcameralist!

				)
			)
		)
	)
	echo.
	
	if !bat_counter! equ 0 (
		set /P bat_choice=No CapturedFiles directories found matching !bat_captureddate!
		goto :CHOOSECAP_END
	)
	
	
	if !bat_counter! equ 1 (
		set bat_capturedfilesdir=!bat_tempfilesdir!
		set bat_dirname=!bat_tempdirname!
		set bat_capdirname=!bat_tempdirname!
		set bat_found=true
		echo.
		echo         Automatically selecting !bat_capturedfilesdir! because there is only one choice. 
		goto :CHOOSECAP2
	)

	set bat_choice=
	set /P bat_choice=Select the CapturedFiles directory to work with ^([CR] to skip this step^): 
	if "!bat_choice!" equ "" goto :CHOOSECAP_END

	set /a bat_capturedcount=0
	set /a bat_archivedcount=0
	set /a bat_counter=0
	set bat_found=false
	set bat_dirname= 

	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\CapturedFiles!bat_finddate!" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					if "!bat_counter!" equ "!bat_choice!" (
						set bat_capturedfilesdir=!bat_targetlocation!\CAMS\CapturedFiles\%%~nxa
						set bat_dirname=%%~nxa
						set bat_capdirname=%%~nxa
						set bat_found=true
					)
				)
			)
		)
	)
	if /i !bat_found! equ false goto :CHOOSECAP

:CHOOSECAP2
	if not defined bat_captureddate (
		set bat_captureddate=!bat_dirname:~0,10!
		set bat_capturedtime=!bat_dirname:~11,8!
	)
	
	rem set bat_captureddate=
	set bat_archivedfilesdir=
	set bat_archdirname=
	set bat_archivedate=
	set bat_submissiondirname=
	set bat_submissiondate=

	echo         Getting file count, please wait...
	rem call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"

	call :GETCAMERAFROMCAPTURED

	call :SAVECONFIG
:CHOOSECAP_END
%bat_return%



:GETCAMERAFROMCAPTURED
!bat_echolog! call :GETCAMERAFROMCAPTURED %*
	set /a bat_capturedcount=0
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_capturedfilesdir!\FF???_*.bin" /b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_capturedfilesdir!\FF???_*.bin" /b /a-d`) do (
		set /a bat_capturedcount+=1
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)

!bat_echolog! return-:GETCAMERAFROMCAPTURED [bat_camera=!bat_camera!, bat_capturedcount=!bat_capturedcount!]
%bat_return%




:	rem 5. SkippedFrames ******************************************
:SKIPPEDFRAMES
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\skippedFrames.bat "!bat_capturedfilesdir!" /v /ok
	     call !bat_exedir!\SkippedFrames.bat "!bat_capturedfilesdir!" /v /ok

	cd /d !bat_exedir!
	
	pause
%bat_return%




	rem 6. Choose ArchivedFiles directory ***********************
:CHOOSEARCH
	rem Choose Archived Directory
	echo.
	set /a bat_counter=0

	set bat_finddate=

	if "!bat_captureddate!" neq "" (
		set bat_finddate=\!bat_captureddate!*
	)


	echo    Listing of ArchivedFiles:
	echo.
	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\ArchivedFiles!bat_finddate!" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					rem echo      !bat_counter!. !bat_targetlocation!\CAMS\ArchivedFiles\%%~nxa
					set bat_tempfilesdir=!bat_targetlocation!\CAMS\ArchivedFiles\%%~nxa
					set bat_tempdirname=%%~nxa
					set bat_temp=%%~nxa

					set bat_tempcameralist=
					set bat_prevcamera=
					for /f "usebackq tokens=*" %%b in (`dir "!bat_targetlocation!\CAMS\CapturedFiles\!bat_temp!\FF*.bin" /a-d /b /on`) do (
						set bat_temp2=%%~nxb
						set bat_tempcamera=!bat_temp2:~2,3!
						if /i "!bat_tempcamera!" neq "!bat_prevcamera!" (
							set bat_prevcamera=!bat_tempcamera!
							set bat_tempcameralist=!bat_tempcameralist! !bat_tempcamera!
						)
					)
					echo     !bat_counter!.  !bat_targetlocation!\CAMS\CapturedFiles\%%~nxa   !bat_tempcameralist!
				)
			)
		)
	)
	echo.

	if !bat_counter! equ 0 (
		if not defined bat_autonomous (
			set /P bat_choice=No ArchivedFiles directories found matching !bat_captureddate!
			goto :CHOOSESEARCH_END
		)
	)

	if !bat_counter! equ 1 (
		set bat_archivedfilesdir=!bat_tempfilesdir!
		set bat_dirname=!bat_tempdirname!
		set bat_archdirname=!bat_tempdirname!
	    set bat_archiveddate=!bat_dirname:~0,10!
		set bat_found=true
		echo.
		echo         Automatically selecting !bat_archivedfilesdir! because there is only one choice
		goto :CHOOSEarch2
	)

	
	set bat_choice=
	set /P bat_choice=Select the ArchivedFiles directory to work with ^([CR] to skip this step^) : 
	if "!bat_choice!" equ "" goto :CHOOSESEARCH_END

	set /a bat_counter=0
	set bat_found=false
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\ArchivedFiles!bat_finddate!" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					if "!bat_counter!" equ "!bat_choice!" (
						set bat_archivedfilesdir=!bat_targetlocation!\CAMS\ArchivedFiles\%%a
						set bat_found=true
						set bat_dirname=%%~nxa
						set bat_archdirname=%%~nxa
						set bat_archiveddate=!bat_dirname:~0,10!
					)
				)
			)
		)
	)
	if /i !bat_found! equ false goto :CHOOSEARCH

:CHOOSEarch2
	if not defined bat_captureddate (
		set bat_captureddate=!bat_dirname:~0,10!
		set bat_capturedtime=!bat_dirname:~11,8!
	)
	echo         Getting file count, please wait...
	rem call :GETFILECOUNT bat_archivedcount "!bat_archivedfilesdir!"

	call :GETCAMERAFROMARCHIVED

	if exist "!bat_archivedfilesdir!\FTPdetectinfo.txt" (
		set bat_detectfile=!bat_archivedfilesdir!\FTPdetectinfo.txt
	) else (
		if exist "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_archiveddate!.txt" (
			set bat_detectfile=!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_archiveddate!.txt
rem			echo     move /y "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_archiveddate!.txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"
rem			         move /y "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_archiveddate!.txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"
		)
	)
	
	call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount
	call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!" "!bat_detectfile!"


	call :GETCONFIRMEDCOUNT bat_confirmedmeteorcount
	call "!bat_exedir!\FixDetectPaths.bat" "!bat_confirmedfilesdir!"
	call :SAVECONFIG

:CHOOSESEARCH_END
%bat_return%


:GETCAMERAFROMARCHIVED
	set /a bat_archivedcount=0
	rem echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedfilesdir!\FF???_*.bin" /b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FF???_*.bin" /b /a-d`) do (
		set /a bat_archivedcount+=1
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
%bat_return%


:GETMETEORCOUNTARCHIVED
!bat_echolog! call :GETMETEORCOUNTARCHIVED %*
	set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	set bat_archivedmeteorcount=
	set bat_latestcal=

	if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
		set bat_detectfile=FTPdetectinfo.txt

		if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
			set bat_latestcal=
			set /a bat_archivedmeteorcount=0

			goto :GETMETEORCOUNTARCHIVED_END
		)
	)

	
	if /i "!bat_archivedfilesdir!" equ "" (
		goto :GETMETEORCOUNTARCHIVED_END
	)

	set bat_latestcal=
	set /a bat_archivedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`^) do ...
	for               /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`) do (
		set /a bat_archivedmeteorcount+=1
		set bat_latestcal=%%a
	)
	
:GETMETEORCOUNTARCHIVED_END
!bat_echolog! return-:GETMETEORCOUNTARCHIVED [!bat_archivedmeteorcount!, !bat_latestcal!, !bat_archivedfilesdir!\!bat_detectfile!]
%bat_return%


	rem 7a. Cal Update ********************************************
:CALUPDATE
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :CALUPDATE_END
	)
	
	echo.
	echo Typically, you would calibrate using the ArchivedFiles dir, however,
	echo there may be times when the Meteor Count is low and you'd need to 
	echo calibrate using the CapturedFiles dir.  
	echo.
	echo Instructions: When asked to "Navigate to FF Folder for Reprocessing", 
	echo navigate to either the "!bat_archivedfilesdir" or 
	echo "!bat_capturedfilesdir!" and click OK.  
	echo.
	echo Press "1" until the "Mean O-C" value is less than 1.00. Then look at the 
	echo "Number of calstars used".  If the number is less than 100, you can run 
	echo the FTP_MeteorCal_Update again with the same or later time until the 
	echo "Mean O-C" value is less than 1.00 with the "Number of calstars used" 
	echo greater than 99.  If that method fails, run FTP_MeteorCal to perform a
	echo manual calibration.  Then verify your manual calibration using 
	echo FTP_MeteorCal_Update using the Mean O-C and calstars targets.
	echo.
	echo Write down the date/time of the FF file used for calibration. The 
	echo best time to do this is just before hitting "c". 
	echo.
	set /P 
	echo.

	echo call !bat_exedir!\FTP_MeteorCal_Update.exe "!bat_caldir!" "!bat_archivedfilesdir!"
	     call !bat_exedir!\FTP_MeteorCal_Update.exe "!bat_caldir!" "!bat_archivedfilesdir!"
	rem set bat_returncode=!errorlevel!

	echo.
	echo Be sure to write down the date/time of the FF file used for calibration.
	set bat_recent_error_msg=Recent process operation: 7a.
	pause
	echo.
:CALUPDATE_END
%bat_return%




	rem 7b. Cal Auto Update ********************************************
:CALUPDATEAUTO
!bat_echolog! call :CALUPDATEAUTO %* [bat_archivedmeteorcount=!bat_archivedmeteorcount!]
	set bat_returncode=0
	set bat_retval=failed
	if /i "!bat_submissionfilesdir!" neq "" (
		!bat_echolog!
		!bat_echolog! '    You probably don't want to do this - you have already run Submission: 
		if not defined bat_autonomous (
			set /p bat_choice=[Enter] to quit, 
			set bat_returncode=1
			!bat_echolog! '    set bat_returncode=[!bat_returncode!]
			goto :CALUPDATEAUTO_END
		)
	)
	
	rem should be something like:
	rem   call :autocalupdate.bat 100 1.00 "!bat_caldir!" "!bat_capturedfilesdir!"
	rem
	rem and then check the autocal log for success/failure


	if /i "!bat_archivedmeteorcount!" equ "0" (
		set bat_recent_error_msg=ERROR - 7b. Auto Calibration failed - Meteor Count is 0. Nothing to calibrate.
		!bat_echolog! '    !bat_recent_error_msg!
		rem set bat_returncode=1
		rem goto :CALUPDATEAUTO_END
		!bat_echolog! '    call !bat_exedir!\FTP_MeteorCal_AutoUpdate.exe !bat_calnstars! !bat_caloc! "!bat_caldir!" "!bat_capturedfilesdir!"
					       call !bat_exedir!\FTP_MeteorCal_AutoUpdate.exe !bat_calnstars! !bat_caloc! "!bat_caldir!" "!bat_capturedfilesdir!"
		set bat_returncode=!errorlevel!
		!bat_echolog! '    Return code from FTP_MeteorCal_AutoUpdate.exe is: !bat_returncode!
		set bat_retval=executed
	) else (
		!bat_echolog! '    call !bat_exedir!\FTP_MeteorCal_AutoUpdate.exe !bat_calnstars! !bat_caloc! "!bat_caldir!" "!bat_capturedfilesdir!"
					       call !bat_exedir!\FTP_MeteorCal_AutoUpdate.exe !bat_calnstars! !bat_caloc! "!bat_caldir!" "!bat_capturedfilesdir!"
		set bat_returncode=!errorlevel!
		!bat_echolog! '    Return code from FTP_MeteorCal_AutoUpdate.exe is: !bat_returncode!
		set bat_retval=executed
	)
	
	!bat_echolog!
	rem Validate the AutoCalUpdate.log file
	set bat_autocal_success=0
	for /f "usebackq tokens=1-12" %%a in (`find /i "camera" "!bat_capturedfilesdir!\AutoCalUpdate.log"^|find /i "camera !bat_camera!"`) do (
		echo %%a,%%b,%%c,%%e,%%f,%%g,%%h,%%i
		set bat_autocal_camera=%%b
		set bat_autocal_success=%%c
		set bat_autocal_nstars=%%d
		set bat_autocal_oc=%%e
		set bat_autocal_fffile=%%f
		set bat_autocal_calfile=%%g
		
		if !bat_autocal_oc! GTR !bat_caloc! (
			set bat_autocal_success=1
			set bat_returncode=1
			set bat_recent_error_msg=ERROR - 7b. Auto Calibration failed - ERROR   O-C !bat_autocal_oc! GTR !bat_caloc!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog! '    Camera:	!bat_autocal_camera!
			!bat_echolog! '    Success:	FAILED
			!bat_echolog! '    nStars:	!bat_autocal_nstars!
			!bat_echolog! '    O-C:	!bat_autocal_oc!
			!bat_echolog! '    FF file:	!bat_autocal_fffile!
			!bat_echolog! '    calfile:	!bat_autocal_calfile!
			!bat_echolog!

			rem Delete the cal file if the O-C value is too high, even though
			rem the .exe program thinks it's ok. 
			if exist "!bat_caldir!\!bat_autocal_calfile!" (
				del "!bat_caldir!\!bat_autocal_calfile!"
			)
			
			!bat_echolog! '    !bat_recent_error_msg!
			
		)
	)
	
	if /i "!bat_autocal_success!" neq "0" (
		set bat_returncode=1
		!bat_echolog! '    set bat_returncode=[!bat_returncode!]
		set bat_recent_error_msg=ERROR - 7b.a. Auto Calibration failed
		!bat_echolog! '    !bat_recent_error_msg!
	) else (
		!bat_echolog!
		!bat_echolog! '    Camera:	!bat_autocal_camera!
		!bat_echolog! '    Success:	SUCCESS
		!bat_echolog! '    nStars:	!bat_autocal_nstars!
		!bat_echolog! '    O-C:		!bat_autocal_oc!
		!bat_echolog! '    FF file:	!bat_autocal_fffile!
		!bat_echolog! '    calfile:	!bat_autocal_calfile!
		!bat_echolog!
		set bat_recent_error_msg=SUCCESS - 7b. Auto Calibration successful [!bat_autocal_calfile!, !bat_autocal_nstars!, !bat_autocal_oc!]
		!bat_echolog! '    !bat_recent_error_msg!
	)
	

:CALUPDATEAUTO_END
!bat_echolog! return-:CALUPDATEAUTO [!bat_retval!, !bat_returncode!]
if not defined bat_autonomous (pause)
%bat_return%


	rem 7c. Cal Auto Update with prompt ********************************************
:CALUPDATEAUTOPROMPT
!bat_echolog! call :CALUPDATEAUTOPROMPT %*

	set bat_retval=
	set bat_returncode=
	set bat_savedefaultnstars=!bat_calnstars!
	set bat_savedefaultoc=!bat_caloc!
:CALUPDATEAUTOPROMPT2
	
	set bat_choice=
	set /p bat_choice=Enter the minimum number of Cal Stars [!bat_calnstars!]: 
	if /i "!bat_choice!" equ "q" goto :CALUPDATEAUTOPROMPT_END
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_calnstars!)
	
	if /i !bat_choice! lss 30 (
		echo.
		echo     ERROR - 7c. Minimum number of Cal stars supported is 30 
		echo.
		goto :CALUPDATEAUTOPROMPT2
	)
	set /a bat_calnstars=!bat_choice!
	
	set bat_choice=
	set /p bat_choice=Enter the minimum Main )-C [!bat_caloc!]: 
	if /i "!bat_choice!" equ "q" goto :CALUPDATEAUTOPROMPT_END
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_caloc!)
	call :CALUPDATEAUTO
	set bat_calnstars=!bat_savedefaultnstars!
	set bat_caloc=!bat_savedefaultoc!
	set bat_recent_error_msg=Recent process operation: 7c.

:CALUPDATEAUTOPROMPT_END
!bat_echolog! return-:CALUPDATEAUTOPROMPT [!bat_retval!, !bat_returncode!]
pause
%bat_return%





	rem 7d. Manual Calibration ************************************
:CAL
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set bat_choice=
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :CAL_END
	)

	set bat_cal_instructionfile=!bat_exedir!\temp_cal_instructions.txt
	set bat_retval=failed
	set bat_recent_error_msg=ERROR - 7d. The calibration was aborted
	set bat_fov=
	set bat_ranew=
	set bat_retval2=
	set bat_retval1=
	set bat_cal_FF_time=

		rem bat_precalfile is the most recently created cal file in the directory
	set bat_cal_ff_time=
	set bat_precalfile=
	set bat_precalfilename=
	rem echo '    for /f "usebackq tokens=*" %%a in ^(`dir "!bat_caldir!\CAL!bat_camera!*.txt" /b /a-d /od`^) do ^(
	for           /f "usebackq tokens=*" %%a in  (`dir "!bat_caldir!\CAL!bat_camera!*.txt" /b /a-d /od`) do (
		set bat_precalfile=!bat_caldir!\%%~a
		set bat_precalfilename=%%~a
	)
	
	
		rem Get the cal file from the current FTPdetectinfo.txt file
	set bat_temp=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	if not exist "!bat_archivedfilesdir!" (
		echo '    ERROR - 7d. - ArchivedFiles dir does not exist for: "!bat_archivedfilesdir!".
		echo.
		set /p bat_choice=Press Enter to continue or [Q]uit: 
		if /i "!bat_choice!" equ "q" goto :CAL_END
		goto :CAL02
	)

	if not exist "!bat_archivedfilesdir!\!bat_temp!" (
		set bat_temp=FTPdetectinfo.txt
	)
	set bat_detectcalfile=
	set bat_detectcalfilename=
	rem echo '    for /f "usebackq tokens=* skip=2" %%a in ^(`find /i "CAL!bat_camera!_" "!bat_archivedfilesdir!\!bat_temp!"`^) do ^(
	for           /f "usebackq tokens=* skip=2" %%a in  (`find /i "CAL!bat_camera!_" "!bat_archivedfilesdir!\!bat_temp!"`) do (
		set bat_detectcalfile=!bat_caldir!\%%~a
		set bat_detectcalfilename=%%~a
	)
	
			echo.>"!bat_cal_instructionfile!"
			echo '  The current captured date is:        !bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!>>"!bat_cal_instructionfile!"
			echo '  The most recent  Cal file is: !bat_precalfilename!>>"!bat_cal_instructionfile!"
			echo '  The detect file is using Cal: !bat_detectcalfilename!>>"!bat_cal_instructionfile!"
			echo '     ^("!bat_archivedfilesdir!\!bat_temp!"^)>>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"
	echo.
	echo '  The current captured date is:        !bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!
	echo '  The most recent  Cal file is: !bat_precalfilename!
	echo '  The detect file is using Cal: !bat_detectcalfilename!
	echo '     ^("!bat_archivedfilesdir!\!bat_temp!"^)
	echo.
	rem set bat_choice=
	rem set /p bat_choice=Press Enter to continue or [Q]uit: 
	rem if /i "!bat_choice!" equ "q" goto :CAL_END

	set bat_retval1=
	set bat_retval2=
	echo   call "!bat_exedir!\ValidateCal.bat" /cal "!bat_detectcalfile!"
	       call "!bat_exedir!\ValidateCal.bat" /cal "!bat_detectcalfile!"

	echo.
	echo   RA=!bat_retval1!, DEC=!bat_retval2!, time=!bat_retval3!
	call :CAL_GETFOV
	echo   FOV=!bat_fov!
	echo.
			echo.>>"!bat_cal_instructionfile!"
			echo   RA=!bat_retval1!, DEC=!bat_retval2!, time=!bat_retval3!>>"!bat_cal_instructionfile!"
			echo   FOV=!bat_fov!>>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"
	
	set bat_choice=
	echo Enter the timestamp of the FF you intend to use for calibration ^(in hhmmss format^) 
	set /p bat_choice=[Or press Enter to skip or [Q]uit]: 

	if /i "!bat_choice!" equ "q" goto :CAL_END

	if defined bat_choice (
		set bat_cal_FF_time=!bat_choice!
		echo     call :CALC_CAL_VALUES !bat_retval1! !bat_retval2! !bat_choice! !bat_retval3! "!bat_detectcalfile!"
		         call :CALC_CAL_VALUES !bat_retval1! !bat_retval2! !bat_choice! !bat_retval3! "!bat_detectcalfile!"
	)

	call :CAL_INSTRUCTIONS
	echo.
	if defined  bat_cal_FF_time (
		echo     Then, considering the new FF file with a time segment value
		echo     of !bat_choice!, you will want to enter the following values:
		echo        FOV = !bat_fov!
		echo        RA  = !bat_ranew:~0,-4!.!bat_ranew:~-4!
		echo        DEC = !bat_retval2!
				echo     Then, considering the new FF file with a time segment value>>"!bat_cal_instructionfile!"
				echo     of !bat_choice!, you will want to enter the following values:>>"!bat_cal_instructionfile!"
				echo        FOV = !bat_fov!>>"!bat_cal_instructionfile!"
				echo        RA  = !bat_ranew:~0,-4!.!bat_ranew:~-4!>>"!bat_cal_instructionfile!"
				echo        DEC = !bat_retval2!>>"!bat_cal_instructionfile!"
	)
	goto :CAL04

:CAL02
	echo.
	CALL :CAL_INSTRUCTIONS
	goto :CAL04

:CAL04
	start "FTP_MeteorCal.exe Instructions" cmd.exe /t:f0 /k "type "!bat_cal_instructionfile!""
	echo.
	echo.
	echo Move the instructions window to a location where you can use it as a reference.
	set bat_choice=
	set /p bat_choice=Press Enter to continue or [Q]uit: 
	if /i "!bat_choice!" equ "q" goto :CAL_END

	echo     call "!bat_exedir!\FTP_MeteorCal.exe" !bat_camera! "!bat_caldir!"
	         call "!bat_exedir!\FTP_MeteorCal.exe" !bat_camera! "!bat_caldir!"
	rem set bat_returncode=!errorlevel!
	echo.
	
	!bat_echolog!
	
	set bat_manualcalfile=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_caldir!\CAL!bat_camera!*.txt" /b /a-d /od`) do (
		set bat_manualcalfile=!bat_caldir!\%%~a
	)

	echo.
	echo.
	set bat_choice=
	set /p bat_choice=Close the instructions window: 


:CAL05
	if /i "!bat_precalfile!" neq "!bat_manualcalfile!" (
		echo.
		echo   SUCCESS
		echo   Be sure to write down the date/time of the FF file used for calibration. 
		echo.
		 !bat_echolog! '    call "!bat_exedir!\ValidateCal.bat" /cal "!bat_manualcalfile!"
		 call "!bat_exedir!\ValidateCal.bat" /cal "!bat_manualcalfile!">>"!bat_logfile!"
		 call "!bat_exedir!\ValidateCal.bat" /cal "!bat_manualcalfile!"
		
		echo.
		echo.
		echo '    Next steps are:
		echo '      1^) Run AutoCams option "7b. Auto Calibration Update" to fine tune this manual calibration
		echo '      2^) Run AutoCams option "9. Apply Cal to Archived" once you have a good calibration
		echo.
		echo.
	pause
		call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount
		set bat_recent_error_msg=SUCCESS - 7d. "!bat_manualcalfile!"
		set bat_retval=success

	) else (
		set bat_recent_error_msg=ERROR - 7d. The calibration failed - "!bat_precalfile!"
		echo.
		!bat_echolog! '    !bat_recent_error_msg!
		echo.
		echo '    We're assuming this is in error because this routine generated a cal file that 
		echo '    is the same name as the previous cal file or that it did not generate a cal
		echo '    file at all.
		echo.
		echo '    This can be a valid outcome if you chose the same FF file as a previous 
		echo '    calibration attempt.  If you believe that this attempt generated a 
		echo '    better outcome, then...
		set bat_choice=
		set /P bat_choice=Press Enter to continue or [Q]uit: 
		if not defined bat_choice (
			set bat_precalfile=!bat_precalfile!.
			goto :CAL05
		)
		if /i "!bat_choice!" equ "q" goto :CAL_END
		goto :CAL_END
	)
	
	echo.

:CAL_END
!bat_echolog! return-:CAL [before:!bat_precalfile!, after:!bat_manualcalfile!]
if exist "!bat_cal_instructionfile!" (del /q "!bat_cal_instructionfile!")
%bat_return%


:CAL_INSTRUCTIONS
	echo.
	echo     When the File chooser dialog appears, navigate to and select an FF file 
	echo     named something like this: 
	echo        FF!bat_camera!_!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!_!bat_cal_FF_time!...
	echo.
	echo     After that, you will be asked for the FOV, RA, and DEC of the 
	echo     new FF file.  
	echo.
	echo     In the MeteorCal program:
	echo       - Press ESC to re-enter FOV, RA, and DEC at any time during star matching
	echo       - Do the manual star matching from right to left
	echo       - Press Enter after each match
	echo       - Press F and B to skip forward or backward
	echo       - When you have matched about 80 or more stars, press "C"
	echo       - Then press "1" to discard outliers until the star count gets 
	echo         between 50 and 60.  
	echo       - Finally, press Ctrl+P to complete the calibration and return to the menu.
	echo.
			echo.>>"!bat_cal_instructionfile!"
			echo     When the File chooser dialog appears, navigate to and select an FF file >>"!bat_cal_instructionfile!"
			echo     named something like this: >>"!bat_cal_instructionfile!"
			echo        FF!bat_camera!_!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!_!bat_cal_FF_time!...>>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"
			echo     After that, you will be asked for the FOV, RA, and DEC of the >>"!bat_cal_instructionfile!"
			echo     new FF file.  >>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"
			echo     In the MeteorCal program:>>"!bat_cal_instructionfile!"
			echo       - Press ESC to re-enter FOV, RA, and DEC at any time during star matching>>"!bat_cal_instructionfile!"
			echo       - Do the manual star matching from right to left>>"!bat_cal_instructionfile!"
			echo       - Press Enter after each match>>"!bat_cal_instructionfile!"
			echo       - Press F and B to skip forward or backward>>"!bat_cal_instructionfile!"
			echo       - When you have matched about 80 or more stars, press "C">>"!bat_cal_instructionfile!"
			echo       - Then press "1" to discard outliers until the star count gets >>"!bat_cal_instructionfile!"
			echo         between 50 and 60.  >>"!bat_cal_instructionfile!"
			echo       - Finally, press Ctrl+P to complete the calibration and return to the menu.>>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"
			echo   If the calibration is successful...>>"!bat_cal_instructionfile!"
			echo     Next steps are:>>"!bat_cal_instructionfile!"
			echo       1^) Run AutoCams option "7b. Auto Calibration Update" to fine tune this manual calibration>>"!bat_cal_instructionfile!"
			echo       2^) Run AutoCams option "9. Apply Cal to Archived" once you have a good calibration>>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"
:CAL_INSTRUCTIONS_END
%bat_return%



:CALC_CAL_VALUES
	set bat_calra=%~1
	set bat_caldec=%~2
	set bat_choice=%~3
	set bat_time=%~4
	set bat_CCV_filefull=%~5
	set bat_CCV_file=%~n5
	set bat_CCV_yy=!bat_CCV_file:~7,4!
	set bat_CCV_mm=!bat_CCV_file:~11,2!
	set bat_CCV_dd=!bat_CCV_file:~13,2!
	
	set bat_CCV_capyy=!bat_captureddate:~0,4!
	set bat_CCV_capmm=!bat_captureddate:~5,2!
	set bat_CCV_capdd=!bat_captureddate:~8,2!

	call :date2jdate bat_CCV_jd_detcal %bat_CCV_yy% %bat_CCV_mm% %bat_CCV_dd%
	call :date2jdate bat_CCV_jd_cap %bat_CCV_capyy% %bat_CCV_capmm% %bat_CCV_capdd%
	set /a "bat_CCV_ra_offset=(bat_CCV_jd_cap - bat_CCV_jd_detcal)*3650000/300"


	rem calculate the entered time in hours
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~0,2! bat_hh
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~2,2!00 bat_mm
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~4,2!00 bat_ss

	echo       set /a "bat_hour=((!bat_ss! / 60) + !bat_mm!) / 60) + !bat_hh!00"
		  set /a "bat_mmdecimal=((!bat_ss! / 60) + !bat_mm!) / 60"
	set /a bat_hour=!bat_hh!00 + !bat_mmdecimal!
	set bat_hourdisplay=!bat_hh!.!bat_mmdecimal!


	rem calculate the old cal file time in hours
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~0,2! bat_timehh
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~3,2!00 bat_timemm
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~6,2!00 bat_timess

	set /a "bat_timemmdecimal=((!bat_timess! / 60) + !bat_timemm!) / 60"
	set /a bat_timetotal=!bat_timehh!00+!bat_timemmdecimal!
	set bat_timemmdecimal=!bat_timemmdecimal!0000
	set bat_timemmdecimal=!bat_timemmdecimal:~0,4!
	set bat_timetotal=!bat_timehh!!bat_timemmdecimal!

	set /a bat_timediff=!bat_hour!00 - !bat_timetotal!
	set /a "bat_diffdegrees=(bat_timediff * 15)"
	rem echo       bat_diffdegrees=!bat_diffdegrees!
	rem echo       bat_CCV_RA_offset=!bat_CCV_RA_offset!
	set /a "bat_diffdegrees=bat_diffdegrees+bat_CCV_RA_offset


	rem Caluclate the new RA value based on the difference in hours
	set bat_temp2=
	call "!bat_exedir!\STRIPZEROS.bat" !bat_calra! bat_calra
	for /f "usebackq tokens=1,2 delims=." %%a in ('!bat_calra!') do (
		set bat_radeg=%%a
		set bat_radegdecimal=%%b

		set bat_temp2=!bat_radegdecimal!0000
		set bat_temp2=!bat_temp2:~0,4!
		set bat_ratotal=!bat_radeg!!bat_temp2!

		set /a bat_ranew=!bat_ratotal! + !bat_diffdegrees!
		if !bat_ranew! GEQ 3600000 (
			set /a "bat_ranew=!bat_ranew! - 3600000"
		)
	)
	
	call :CAL_GETFOV

	echo.
	echo     Data from current calibration file: !bat_detectcalfile!
	echo        time=!bat_time!, !bat_timetotal:~0,-4!.!bat_timetotal:~-4!
	echo        RA  =!bat_retval1!, !bat_ratotal!
	echo        DEC =!bat_retval2!
	echo.
	rem echo     bat_timediff=!bat_timediff!
	rem echo     bat_diffdegrees=!bat_diffdegrees!
	rem echo.
	echo     Data from the FF file based on the entered time segment: !bat_choice!
	echo        time=!bat_hour:~0,-2!.!bat_hour:~-2!
	echo        RA  =!bat_ranew:~0,-4!.!bat_ranew:~-4!
	echo        DEC =!bat_caldec!
	echo.

			echo.>>"!bat_cal_instructionfile!"
			echo     Data from current calibration file: !bat_detectcalfile!>>"!bat_cal_instructionfile!"
			echo        time=!bat_time!, !bat_timetotal:~0,-4!.!bat_timetotal:~-4!>>"!bat_cal_instructionfile!"
			echo        RA  =!bat_retval1!, !bat_ratotal!>>"!bat_cal_instructionfile!"
			echo        DEC =!bat_retval2!>>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"
			rem echo     bat_timediff=!bat_timediff!>>"!bat_cal_instructionfile!"
			rem echo     bat_diffdegrees=!bat_diffdegrees!>>"!bat_cal_instructionfile!"
			rem echo.>>"!bat_cal_instructionfile!"
			echo     Data from the FF file based on the entered time segment: !bat_choice!>>"!bat_cal_instructionfile!"
			echo        time=!bat_hour:~0,-2!.!bat_hour:~-2!>>"!bat_cal_instructionfile!"
			echo        RA  =!bat_ranew:~0,-4!.!bat_ranew:~-4!>>"!bat_cal_instructionfile!"
			echo        DEC =!bat_caldec!>>"!bat_cal_instructionfile!"
			echo.>>"!bat_cal_instructionfile!"
		
:CALC_CAL_VALUES_END
rem echo return-:CALC_CAL_VALUES [in=%*] [!bat_timetotal!, !bat_hour!, !bat_ranew!, !bat_diffdegrees!]
%bat_return%




:CAL_GETFOV
	if exist "!bat_precalfile!" (
		for /f "usebackq tokens=1-8 skip=2" %%a in (`find /i "fov dimension" "!bat_precalfile!"`) do (
			set bat_fov=%%h
		)
	)
:CAL_GETFOV_END
%bat_return%





:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	setlocal
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4
	ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	SETLOCAL ENABLEDELAYEDEXPANSION
	set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
	set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
	set /a J= J+2-12*L,      I= 100*(N-49)+I+L
	set /a YYYY= I,  MM=100+J,  DD=100+K
	set MM=!MM:~-2!
	set DD=!DD:~-2!
	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)
EXIT /b 0











	rem 9. Apply cal to detectinfo *******************************
:APPLY

	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :APPLY_END
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		goto :APPLY_END
	)
	
	set bat_temp=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	if not exist "!bat_archivedfilesdir!\!bat_temp!" (
		set bat_temp=FTPdetectinfo.txt
	)
	
	echo call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	     call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	rem set bat_returncode=!errorlevel!

	set bat_latestcal=
	echo '    for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\!bat_temp!"`^) do...
	for           /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_archivedfilesdir!\!bat_temp!"`) do (
		if not defined bat_latestcal (
			set bat_latestcal=%%a
			echo.
			echo   Reading the current "!bat_temp!" file and scanning for the cal
			echo   file now in use...
			echo      "!bat_latestcal!"
			set bat_recent_error_msg=9.APPLY "!bat_latestcal!"
		)
	)


:APPLY_END
	pause
%bat_return%



	rem 9. Apply cal to detectinfo *******************************
:APPLYAUTO
!bat_echolog! call :APPLYAUTO %*
	set bat_retval=failed
	set bat_returncode=0
	set bat_latestcal=

	set bat_recent_error_msg=SUCCESS - 9.a.APPLYAUTO - "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" !bat_autonomous!

	if "!bat_archivedmeteorcount!" equ "0" (
		set bat_recent_error_msg=ERROR - 9.a.APPLYAUTO [%*] failed. Meteor Count is 0. Nothing to calibrate.
		!bat_errorlog! '    !bat_recent_error_msg!
		set bat_returncode=1
		goto :APPLYAUTO_END
	) else (
		!bat_echolog! '     call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" !bat_autonomous!
						    call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" !bat_autonomous!
		set bat_returncode=!errorlevel!
		!bat_echolog! '    ERRORLEVEL=[!bat_returncode!]
		if !bat_returncode! neq 0 (
			set bat_recent_error_msg=ERROR failed - 9.a.APPLYAUTO "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" !bat_autonomous!
			!bat_echolog! '    !bat_recent_error_msg!
			goto :APPLYAUTO_END
		)

		set bat_temp=!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
		if not exist "!bat_temp!" (
			set bat_temp=!bat_archivedfilesdir!\FTPdetectinfo.txt
		)

rem		echo               for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_temp!"`^) do ...
		!bat_echolog! '    for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_temp!"`^) do ...
		for                    /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_temp!"`) do (
			if not defined bat_latestcal (
				set bat_latestcal=%%a
			)
		)
	)

	!bat_echolog!
	!bat_echolog! '    Cal file in "!bat_temp!" is:
	!bat_echolog! '        "!bat_latestcal!"
	!bat_echolog!
	if defined bat_latestcal (
		set bat_recent_error_msg=SUCCESS - 9.a.APPLYAUTO - "!bat_latestcal!"  in  "!bat_temp!"
		!bat_echolog! '    !bat_recent_error_msg!
		set bat_returncode=0
		set bat_retval=success
	) else (
		set bat_recent_error_msg=ERROR - 9.a.APPLYAUTO [%*] failed to determine latest cal file.
		!bat_echolog! '    !bat_recent_error_msg!
		set bat_returncode=1
		goto :APPLYAUTOEND
	)
	
:APPLYAUTO_END
!bat_echolog! return-:APPLYAUTO [!bat_retval!, bat_returncode=!bat_returncode!, "!bat_latestcal!", !bat_recent_error_msg=!]
%bat_return%




:WAITFORMULTISCAN
	echo :WAITFORMULTISCAN %*
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedfilesdir!\FTPdetectinfo_case???.txt" /b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FTPdetectinfo_case???.txt" /b /a-d`) do (
		echo     Waiting for FTP_Reprocess to release the file: "!bat_archivedfilesdir!\%%a"
		echo     call WaitForFile rw "!bat_archivedfilesdir!\%%a"
		         call WaitForFile rw "!bat_archivedfilesdir!\%%a"
	)
	echo.
%bat_return%



	rem 10. Confirmation ******************************************
:CONFIRM
	if /i "!bat_submissionfilesdir!" neq "" (
			echo.
			echo You probably don't want to do this - you have already run Confirm and Submit.  
			echo Choose "Undo submission" if you need to perform confirmation. 
			set /p bat_choice=Press [enter] to go back to the menu. 
			goto :CONFIRM_END
		)
	)

	set bat_confirmdetect=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	if not exist "!bat_archivedfilesdir!\!bat_confirmdetect!" (
		set bat_confirmdetect=FTPdetectinfo.txt
	)

:CONFIRM2
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		goto :CONFIRM_END
	)
	
	call :GETCONFIRMEDCOUNT

	echo.
	echo When asked to "Navigate to FTP Detection File to Process 
	echo for Coincidence", instead navigate to and select:
	echo   "!bat_archivedfilesdir!\!bat_detectfile!". 
	echo.
	echo start !bat_exedir!\FTP_Confirmation.exe "!bat_archivedfilesdir!\!bat_detectfile!"
	     start !bat_exedir!\FTP_Confirmation.exe "!bat_archivedfilesdir!\!bat_detectfile!"

	call :GETCONFIRMEDCOUNT

	set bat_recent_error_msg=10. Confirmation 
:CONFIRM_END
%bat_return%




:GETCONFIRMEDCOUNT
!bat_echolog! call :GETCONFIRMEDCOUNT %*
	set bat_confirmedmeteorcount=0
	set bat_confirmedcal=
	set bat_confirmedetect=
	set bat_detectfileconf=

	if /i "!bat_archivedfilesdir!" equ "" (
		!bat_echolog! '    bat_archivedfilesdir=blank
		goto :GETCONFIRMEDCOUNT_END
	)

	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!

	if /i "!bat_confirmedfilesdir!" equ "" (
		!bat_echolog! '    bat_confirmedfilesdir=blank
		goto :GETCONFIRMEDCOUNT_END
	)

	set bat_detectfileconf=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	
	if not exist "!bat_confirmedfilesdir!\!bat_detectfileconf!" (
		set bat_detectfileconf=FTPdetectinfo.txt

		if not exist "!bat_confirmedfilesdir!\!bat_detectfileconf!" (
			set /a bat_confirmedmeteorcount=0
				goto :GETCONFIRMEDCOUNT_END
		)
	)
	
	if /i "!bat_detectfileconf!" equ "" (
		!bat_echolog! '    No detect file found...
		goto :GETCONFIRMEDCOUNT_END
	)

	set bat_confirmedcal=
	set /a bat_confirmedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_confirmedfilesdir!\!bat_detectfileconf!"`^) do ...
	for               /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_confirmedfilesdir!\!bat_detectfileconf!"`) do (
		set /a bat_confirmedmeteorcount+=1
		set bat_confirmedcal=%%a
	)

	set bat_confirmeddetect=!bat_detectfileconf!
	call :SAVECONFIG

:GETCONFIRMEDCOUNT_END
!bat_echolog! return-:GETCONFIRMEDCOUNT [!bat_confirmedmeteorcount!, bat_confirmedcal=!bat_confirmedcal!, !bat_confirmedfilesdir!\!bat_confirmdetect!]
%bat_return%




	rem 11. Edit comments.txt file ********************************
:EDITCOMMENTS
	if not defined bat_archivedfilesdir (
		!bat_echolog! '    ERROR - Not defined: bat_archivedfilesdir - ["!bat_archivedfilesdir!"]
		pause
		goto :EDITCOMMENTS_END
	)
	
	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	
	if not exist "!bat_confirmedfilesdir!" (
		!bat_echolog! '    md "!bat_confirmedfilesdir!"
		                   md "!bat_confirmedfilesdir!"
	)

	!bat_echolog! '    call notepad.exe "!bat_confirmedfilesdir!\comments_!bat_camera!.txt"
	                   call notepad.exe "!bat_confirmedfilesdir!\comments_!bat_camera!.txt"

	if defined bat_submissionfilesdir (
		!bat_echolog! '    copy /y "!bat_confirmedfilesdir!\comments_!bat_camera!.txt" "!bat_targetlocation!\cams\SubmissionFiles\!bat_captureddate!\!bat_camera!\EmailFiles"
		                   copy /y "!bat_confirmedfilesdir!\comments_!bat_camera!.txt" "!bat_targetlocation!\cams\SubmissionFiles\!bat_captureddate!\!bat_camera!\EmailFiles"
	)

:EDITCOMMENTS_END
%bat_return%



	rem 12. Apply cal to ConfirmedFiles **************************
:APPLYCONFIRMED
!bat_echolog! call :APPLYCONFIRMED %*
	set bat_retval=failed
	set bat_returncode=0
	set bat_latestconfcal=

	set bat_recent_error_msg=SUCCESS - 12.APPLYAUTO - "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!" !bat_autonomous!

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_returncode=1
		echo.
		!bat_echolog! '    ERROR - 12.Not supported from SubmissionFiles. Use "Undo Submission" if necessary: 
		set bat_returncode=1
		if not defined bat_autonomous (
			pause
		)
		goto :APPLYCONFIRMED_END
	)

	if /i "!bat_archivedfilesdir!" equ "" (
		set bat_returncode=1
		echo.
		!bat_echolog! '    ERROR - 12.You need to Choose ArchivedFiles first:
		if not defined bat_autonomous (
			pause
		)
		goto :APPLYCONFIRMED_END
	)
	
	set bat_archivedfilesdir
	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	set bat_confirmedfilesdir

	set bat_temp=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	if not exist "!bat_confirmedfilesdir!\!bat_temp!" (
		set bat_temp=FTPdetectinfo.txt
	)
		

	if "!bat_confirmedmeteorcount!" equ "0" (
		set bat_recent_error_msg=NOTE - 12.Confirmed Meteor Count is 0. Nothing to calibrate.
		!bat_errorlog! '    !bat_recent_error_msg!
		set bat_returncode=1
		goto :APPLYCONFIRMED_END
	) else (
		!bat_echolog! '     call "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!" !bat_autonomous!
						    call "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!" !bat_autonomous!
		set bat_returncode=!errorlevel!
		!bat_echolog! '    ERRORLEVEL=[!bat_returncode!]
		if !bat_returncode! neq 0 (
			set bat_recent_error_msg=ERROR - 12.APPLYCONFIRMED "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!" !bat_autonomous! failed
			!bat_echolog! '    !bat_recent_error_msg!
			goto :APPLYAUTO_END
		)

		!bat_echolog! '    for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_confirmedfilesdir!\!bat_temp!"`^) do ...
		for                    /f "usebackq tokens=* skip=2" %%a in  (`find /i ".txt" "!bat_confirmedfilesdir!\!bat_temp!"`) do (
			if not defined bat_latestconfcal (
				set bat_latestconfcal=%%a
			)
		)
	)


	!bat_echolog!
	!bat_echolog! '    Cal file in "!bat_confirmedfilesdir!\!bat_temp!":
	!bat_echolog! '    "!bat_latestconfcal!"
	!bat_echolog!
	if defined bat_latestconfcal (
		set bat_recent_error_msg=SUCCESS - 12a. Applied "!bat_latestconfcal!" to "!bat_confirmedfilesdir!\!bat_temp!"
		set bat_returncode=0
		set bat_retval=success
	) else (
		set bat_recent_error_msg=ERROR - 12a.APPLYCONFIRMED unable to define the confirmed calfile.
		!bat_echolog! '    !bat_recent_error_msg!
		set bat_returncode=1
		goto :APPLYCONFIRMED_END
	)

	
:APPLYCONFIRMED_END
!bat_echolog! return-:APPLYCONFIRMED [!bat_retval!, !bat_returncode!, "!bat_latestcal!", !bat_recent_error_msg!]
	if not defined bat_autonomous (
		pause
	)
%bat_return%




	rem 13. Submission ********************************************
	rem 13. StageFromConfirmed.bat ********************************
:SUBMIT
echo call :SUBMIT %*
	set bat_returncode=0
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=Not supported from SubmissionFiles. Use "Undo Submission" if necessary: 
		goto :SUBMIT_END
	)
	
	if /i "!bat_captureddate!" equ "" (
		call :CHOOSEDATE
		goto :SUBMIT
	)

	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		goto :SUBMIT_END
	)

	if /i "!bat_archivedfilesdir:~-14!" equ "ArchivedFiles\" (
		echo.
		!bat_echolog! '    ERROR - "!bat_archivedfilesdir!" is missing dir name
		set /p bat_choice=Press Enter to quit  
		goto :SUBMIT_END
	)

	if not exist "!bat_confirmedfilesdir!" (
		echo     WARNING - ConfirmedFiles does not exist ["!bat_confirmedfilesdir!"]
		rem goto :SUBMIT_END
	)



	echo call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!">>"!bat_logfile!"
	echo call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!"
	     call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!"
	set bat_returncode=!errorlevel!
	echo '    bat_returncode=!bat_returncode! [from StageFromConfirmed.bat]
	set bat_submissionfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!
	set bat_submissiondirname=!bat_archdirname!
	set bat_submissiondate=!bat_captureddate!

	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!*" /b /ad`^) do ...
	for      /f "usebackq tokens=*" %%a in  (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!*" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_capturedfilesdir=!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%a
					set bat_capdirname=%%a
					set bat_captureddate=!bat_capdirname:~0,10!
					set bat_capturedtime=!bat_capdirname:~11,8!
				)
			)
		)
	)
	
	
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_captureddate!*" /b /ad`^) do ...
	for      /f "usebackq tokens=*" %%a in  (`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_captureddate!*" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_archivedfilesdir=!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\%%a
					set bat_archdirname=%%a
					set bat_archiveddate=!bat_archdirname:~0,10!
				)
			)
		)
	)
	call :GETFILECOUNT bat_archivedcount "!bat_archivedfilesdir!"
	call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"
	call :GETMETEORCOUNTARCHIVED
	call :GETCONFIRMEDCOUNT
:SUBMIT_END
	if /i !bat_returncode! neq 0 (
		set bat_recent_error_msg=ERROR - FAILED.2 - 13. StageFromConfirmed.bat "!bat_archivedfilesdir!"
		!bat_echolog! '    !bat_recent_error_msg!
	) else (
		set bat_recent_error_msg=SUCCESS - 13. StageFromConfirmed.bat "!bat_archivedfilesdir!"
		!bat_echolog! '    !bat_recent_error_msg!
	)
	
echo return-:SUBMIT [!bat_returncode!, !bat_submissionfilesdir!]
	pause
%bat_return%




	rem 13. Submission ********************************************
	rem 13. StageFromConfirmed.bat ********************************
:SUBMITAUTO
	set bat_returncode=0
	if /i "!bat_archivedfilesdir:~-14!" equ "ArchivedFiles\" (
		set bat_returncode=1
		set bat_recent_error_msg=ERROR - 13a. "!bat_archivedfilesdir!" is missing dir name
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		goto :SUBMITAUTO_END
	)
	

	echo     call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!" "!bat_capturedfilesdir!" !bat_camera! !bat_autonomous!>>"!bat_logfile!"
	echo     call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!" "!bat_capturedfilesdir!" !bat_camera! !bat_autonomous!
	         call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!" "!bat_capturedfilesdir!" !bat_camera! !bat_autonomous!
	set bat_returncode=!errorlevel!
	!bat_echolog! '    errorlevel=[!bat_returncode!]
	if /i "!bat_returncode!" neq "0" (
		set bat_recent_error_msg=ERROR - 13a. Failed: call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!" "!bat_capturedfilesdir!" !bat_camera! !bat_autonomous!
		!bat_echolog! '    !bat_recent_error_msg!
		goto :SUBMITAUTO_END
	)
	
	set bat_submissionfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!
	set bat_submissiondirname=!bat_archdirname!
	set bat_submissiondate=!bat_captureddate!

	echo     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!*" /b /ad`^) do ...>>"!bat_logfile!"
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!*" /b /ad`^) do ...
	for          /f "usebackq tokens=*" %%a in  (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!*" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_capturedfilesdir=!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%a
					set bat_capdirname=%%a
					set bat_captureddate=!bat_capdirname:~0,10!
					set bat_capturedtime=!bat_capdirname:~11,8!
				)
			)
		)
	)
	
	
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_captureddate!*" /b /ad`^) do ...>>"!bat_logfile!"
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_captureddate!*" /b /ad`^) do ...
	for          /f "usebackq tokens=*" %%a in  (`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_captureddate!*" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_archivedfilesdir=!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\%%a
					set bat_archdirname=%%a
					set bat_archiveddate=!bat_archdirname:~0,10!
				)
			)
		)
	)
	call :GETFILECOUNT bat_archivedcount "!bat_archivedfilesdir!"
	call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"
	call :GETMETEORCOUNTARCHIVED
	call :GETCONFIRMEDCOUNT

:SUBMITAUTO_END
!bat_echolog! return :SUBMITAUTO %* [bat_returncode=!bat_returncode!, !bat_submissionfilesdir!\!bat_camera!]
rem exit /b !bat_returncode!
%bat_return%



	rem 14. Choose SubmissionFiles directory *********************
:CHOOSESUBMISSION
	echo.

	echo bat_captureddate="!bat_captureddate!"
	if /i "!bat_captureddate!" equ "" (
		call :CHOOSEDATE
		goto :CHOOSESUBMISSION
	)


	set bat_finddate=

	if "!bat_captureddate!" neq "" (
		set bat_finddate=%^ ^|find /i "!bat_captureddate!"
	)


	set /a bat_counter=0
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on!bat_finddate!`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on!bat_finddate!`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					echo !bat_counter!. %%a
				)
			)
		)
	)
	echo.

	if !bat_counter! equ 0 (
		set /P bat_choice=No SubmissionFiles directories found matching !bat_captureddate!. Press any key to skip. 
		goto :CHOOSESUBMISSION_END
	)
	set bat_choice=
	set /P bat_choice=Select the SubmissionFiles directory to work with: 
	if "!bat_choice!" equ "" goto :CHOOSESUBMISSION_END

	set /a bat_counter=0
	set bat_found=false
	echo Listing of SubmissionFiles:
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on!bat_finddate!`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					if "!bat_counter!" equ "!bat_choice!" (
						set bat_submissionfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\%%a
						set bat_found=true
						set bat_dirname=%%~nxa
						set bat_submissiondirname=%%~nxa
						set bat_Submissiondate=!bat_dirname:~0,10!
					)
				)
			)
		)
	)
	
:CHOOSESUBMISSION1
	!bat_echolog!   :CHOOSESUBMISSION1
	if /i !bat_found! equ false goto :CHOOSEARCH
	
	
	if not defined bat_captureddate (
		set bat_captureddate=!bat_dirname:~0,10!
		set bat_capturedtime=!bat_dirname:~11,8!
	)

:CHOOSESUBMISSION2
	!bat_echolog!   :CHOOSESUBMISSION2
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /b /ad`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_capturedfilesdir=!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%a
					set bat_capdirname=%%a
					set bat_captureddate=!bat_capdirname:~0,10!
					set bat_capturedtime=!bat_capdirname:~11,8!
				)
			)
		)
	)
	call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"
	
	
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles" /b /ad`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_archivedfilesdir=!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\%%a
					set bat_archdirname=%%a
					set bat_archiveddate=!bat_archdirname:~0,10!
				)
			)
		)
	)
	call :GETFILECOUNT bat_archivedcount "!bat_archivedfilesdir!"
	call :GETMETEORCOUNTARCHIVED

	call :GETCAMERAFROMSUBMISSION
	call :GETCONFIRMEDCOUNT
	set bat_recent_error_msg=14. [!bat_capturedfilesdir!]
:CHOOSESUBMISSION_END
!bat_echolog! return-:CHOOSESUBMISSION [!bat_capturedfilesdir!]
pause
%bat_return%




:GETFILECOUNT [out] bat_capturedcount [in] "dir"
!bat_echolog! call :GETFILECOUNT "%~1"  "%~2"
	set %~1=0
	for /f "usebackq tokens=*" %%a in (`dir "%~2" /b /a-d^|find /i /c ".bin"`) do (
		title set %1=%%a
		      set %1=%%a
	)
!bat_echolog! return-:GETFILECOUNT [%~1=!%1!]
%bat_return%



:GETCAMERAFROMSUBMISSION
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\FF???_*.bin" /b /a-d`) do (
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
%bat_return%



:FORMATDATE [out] bat_dateinput [in] bat_captureddate
	set bat_temp=%2
	set %1=!bat_temp:~5,2!/!bat_temp:~-2!/!bat_temp:~0,4!
%bat_return%




	rem 15. Undo Submission ***************************************
	rem Restore the Archived, Captured, and Confirmed files from 
	rem the SubmissionFiles directory to the basic CAMS subdirs
:RESTORESUBMIT

	if /i "!bat_submissionfilesdir!" equ "" (
		echo.
		set /p bat_choice=Error - SubmissionFiles not set. Use "Choose Submission dir" first: 
		goto :RESTORESUBMIT_END
	)

	call :SEARCHFORDIR "!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\ArchivedFiles\!bat_captureddate!*"
	set bat_archivedfilesdir=!bat_targetlocation!\CAMS\ArchivedFiles\!bat_retval3!
	set bat_archdirname=!bat_retval3!	
	echo     move /y "!bat_retval!" "!bat_targetlocation!\CAMS\ArchivedFiles"
	         move /y "!bat_retval!" "!bat_targetlocation!\CAMS\ArchivedFiles"
	
	echo     move /y "!bat_archivedfilesdir!\FTPdetectinfo.txt" "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt"
	         move /y "!bat_archivedfilesdir!\FTPdetectinfo.txt" "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt"
	     
	rem echo     move /y "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt" "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt"
	rem          move /y "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt" "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt"
	     
	call :SEARCHFORDIR "!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\CapturedFiles\!bat_captureddate!*"
	if defined bat_retval (
		set bat_capturedfilesdir=!bat_targetlocation!\CAMS\CapturedFiles\!bat_retval3!
		set bat_capdirname=!bat_retval3!	
		echo     move /y "!bat_retval!" "!bat_targetlocation!\CAMS\CapturedFiles"
				 move /y "!bat_retval!" "!bat_targetlocation!\CAMS\CapturedFiles"
	) else (
		!bat_echolog! '    NOT FOUND - "!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\CapturedFiles\!bat_captureddate!*"
	)
	     
	call :SEARCHFORDIR "!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\ConfirmedFiles\!bat_captureddate!*"
	if defined bat_retval (
		set bat_confirmedfilesdir=!bat_targetlocation!\CAMS\ConfirmedFiles\!bat_retval3!
		set bat_confdirname=!bat_retval3!	
		echo     move /y "!bat_retval!" "!bat_targetlocation!\CAMS\ConfirmedFiles"
				 move /y "!bat_retval!" "!bat_targetlocation!\CAMS\ConfirmedFiles"

		echo     move /y "!bat_confirmedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt" "!bat_confirmedfilesdir!\FTPdetectinfo.txt"
				 move /y "!bat_confirmedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt" "!bat_confirmedfilesdir!\FTPdetectinfo.txt"

		echo     move /y "!bat_confirmedfilesdir!\FTPdetectinfo.txt" "!bat_confirmedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt"
				 move /y "!bat_confirmedfilesdir!\FTPdetectinfo.txt" "!bat_confirmedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt"

	) else (
		!bat_echolog! '    NOT FOUND - "!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\ConfirmedFiles\!bat_captureddate!*"
	)

	echo     copy /y "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip" "!bat_targetlocation!\CAMS\Submitted"
	         copy /y "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip" "!bat_targetlocation!\CAMS\Submitted"

	set bat_submissionfilesdir=
	set bat_submissiondirname=
	set bat_submissiondate=

	call :GETMETEORCOUNTARCHIVED
	call :GETCONFIRMEDCOUNT

	set bat_temp="!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\ArchivedFiles"
	dir "!bat_temp!"|find /i " 0 File(s)"
	if !errorlevel! equ 0 (
		rd /S /Q "!bat_temp!" 
	) else (
		!bat_echolog! '    ERROR - Seems that the dir didn't get completely moved back:
		!bat_echolog! '            "!bat_temp!"
	)

	set bat_temp="!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\CapturedFiles"
	dir "!bat_temp!"|find /i " 0 File(s)"
	if !errorlevel! equ 0 (
		rd /S /Q "!bat_temp!" 
	) else (
		!bat_echolog! '    ERROR - Seems that the dir didn't get completely moved back:
		!bat_echolog! '            "!bat_temp!"
	)

	set bat_temp="!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\ConfirmedFiles"
	dir "!bat_temp!"|find /i " 0 File(s)"
	if !errorlevel! equ 0 (
		rd /S /Q "!bat_temp!" 
	) else (
		!bat_echolog! '    ERROR - Seems that the dir didn't get completely moved back:
		!bat_echolog! '            "!bat_temp!"
	)
	set bat_recent_error_msg=15. [!bat_capturedfilesdir!]

:RESTORESUBMIT_END
!bat_echolog! return-:RESTORESUBMIT_END [!bat_capturedfilesdir!]
	pause
%bat_return%



:SEARCHFORDIR [out] bat_retval [out] bat_retval2[in]  [out] bat_retval3 bat_basedir
	rem bat_retval	is a fully qualified directory name
	rem bat_retval2 is that path not including the last directory name of the path
	rem bat_retval3 is the last directory name in the path
	
	echo :SEARCHFORDIR "%~1" 
	set bat_retval=
	for /f "usebackq tokens=*" %%a in (`dir "%~1" /s/b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_retval=%%a
					set bat_retval2=%%~dpa::
					set bat_retval2=!bat_retval2:\::=!
					set bat_retval2=!bat_retval2:::=!
					set bat_retval3=%%~nxa
				)
			)
		)
	)

echo return-:SEARCHFORDIR: bat_retval=!bat_retval!, bat_retval2=!bat_retval2!, bat_retval3=!bat_retval3!
%bat_return%



	rem 16. Make Transmit Zip *************************************
:MAKEZIP
!bat_echolog! call :MAKEZIP %*
	set bat_retval=failed
	if /i "!bat_submissionfilesdir!" equ "" (
		echo.
		!bat_echolog!
		!bat_echolog!
		set bat_recent_error_msg=16.ERROR - Run Submission before zipping.
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		if "!bat_autonomous!" neq "autonomous" (
			pause 
		)
		goto :MAKEZIP_END
	)
	
	rem This requires 7za
	if not defined bat_camera (
		set bat_recent_error_msg=16.ERROR - Missing camera number
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :MAKEZIP_END
	)
	
	set bat_tempdir=!bat_captureddate!_!bat_camera!
	
	set  bat_tempsrc=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!\!bat_camera!
	set bat_tempdest=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!
	
	call :PREZIPMOVE "!bat_tempsrc!" "!bat_tempdest!\!bat_camera!"

	set bat_tempcounter=

	goto :MZ_SEVENZIP


:MZ_SEVENZIP
	if exist "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" (
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    Exists: "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"
		if not defined bat_tempcounter (
			set /a bat_tempcounter=2
			set bat_tempdir=!bat_tempdir!_
		) else (
			set /a bat_tempcounter+=1
		)
		rem del "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!.zip"
		goto :MZ_SEVENZIP
	)

	set bat_zipfile=
	call :SEVENZIP
	call :POSTZIPMOVE  "!bat_tempsrc!" "!bat_tempdest!"
	if /i "!bat_returncode!" neq "0" (goto :MAKEZIP_END)

	if not exist "!bat_zipfile!" (
		set bat_recent_error_msg=16.ERROR - Failed to create zip file: "!bat_zipfile!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
	) else (
		set bat_retval=success
		set bat_recent_error_msg=16.SUCCESS - "!bat_zipfile!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
	)
	
:MAKEZIP_END
!bat_echolog! return-:MAKEZIP [!bat_retval!, "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"]
	pause
%bat_return%


:PREZIPMOVE
!bat_echolog! call :PREZIPMOVE %*
	set bat_tempsrc1=%~1
	set bat_tempdest1=%~2
	
	!bat_echolog! '    bat_camera=!bat_camera!
	!bat_echolog! '    bat_tempsrc1=!bat_tempsrc1!
	!bat_echolog! '    bat_tempdest1=!bat_tempdest1!

	echo     move /y "!bat_tempsrc1!\EmailFiles\FTPdetectinfo_*-!bat_camera!-*.txt" "!bat_tempdest1!"
	         move /y "!bat_tempsrc1!\EmailFiles\FTPdetectinfo_*-!bat_camera!-*.txt" "!bat_tempdest1!"

	echo     copy /y "!bat_tempsrc1!\EmailFiles\Cal-!bat_camera!\*.txt" "!bat_tempdest1!"
	    	 copy /y "!bat_tempsrc1!\EmailFiles\Cal-!bat_camera!\*.txt" "!bat_tempdest1!"
:PREZIPMOVE_END
!bat_echolog! return-:PREZIPMOVE ["!bat_tempsrc1!\EmailFiles\FTPdetectinfo_*-!bat_camera!-*.txt"]
%bat_return%



:POSTZIPMOVE
!bat_echolog! call :POSTZIPMOVE %*
	set bat_tempsrc1=%~1
	set bat_tempdest1=%~2
	
	!bat_echolog! '    bat_tempsrc1=!bat_tempsrc1!
	!bat_echolog! '    bat_tempdest1=!bat_tempdest1!

	echo     move /y "!bat_tempdest1!\FTPdetectinfo*.txt" "!bat_tempsrc1!\EmailFiles"
	         move /y "!bat_tempdest1!\FTPdetectinfo*.txt" "!bat_tempsrc1!\EmailFiles"

	echo     copy /y "!bat_tempsrc1!\EmailFiles\Cal-!bat_camera!\*.txt" "!bat_tempdest1!"
	    	 copy /y "!bat_tempsrc1!\EmailFiles\Cal-!bat_camera!\*.txt" "!bat_tempdest1!"
:POSTZIPMOVE_END
!bat_echolog return-:POSTZIPMOVE ["!bat_tempdest1!\FTPdetectinfo*.txt"]
%bat_return%



	rem 16. Make Transmit Zip *************************************
:MAKEZIPAUTO
!bat_echolog! call :MAKEZIPAUTO %*
	set bat_retval=failed
	if /i "!bat_submissionfilesdir!" equ "" (
		echo.
		!bat_echolog!
		!bat_echolog!
		set bat_recent_error_msg=16.a.ERROR - Run Submission before zipping.
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :MAKEZIPAUTO_END
	)
	
	rem This requires 7za
	if not defined bat_camera (
		set bat_recent_error_msg=16.a.ERROR - Missing camera number
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :MAKEZIPAUTO_END
	)

	set bat_tempdir=!bat_captureddate!_!bat_camera!
	
	set  bat_tempsrc=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!\!bat_camera!
	set bat_tempdest=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!
	
	call :PREZIPMOVE "!bat_tempsrc!" "!bat_tempdest!\!bat_camera!"
	
	set bat_tempcounter=
	
	goto :MZA_SEVENZIP
	

:MZA_SEVENZIP
	if exist "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" (
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    Exists: "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"
		if not defined bat_tempcounter (
			set /a bat_tempcounter=2
			set bat_tempdir=!bat_tempdir!_
		) else (
			set /a bat_tempcounter+=1
		)
		rem del "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!.zip"
		goto :MZA_SEVENZIP
	)
	
	set bat_zipfile=
	call :SEVENZIP
	call :POSTZIPMOVE  "!bat_tempsrc!" "!bat_tempdest!"
	if /i "!bat_returncode!" neq "0" (goto :MAKEZIPAUTO_END)

	if not exist "!bat_zipfile!" (
		set bat_recent_error_msg=16.a.ERROR - Failed to create zip file: "!bat_zipfile!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
	) else (
		set bat_retval=success
		set bat_recent_error_msg=16.a.SUCCESS - "!bat_zipfile!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog!     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
	)

:MAKEZIPAUTO_END
!bat_echolog! return-:MAKEZIPAUTO [!bat_retval!, "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"]
%bat_return%




:SEVENZIP
!bat_echolog! call :SEVENZIP
	set bat_returncode=0
	set bat_zipfile=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip
	set bat_zipsrc=!bat_tempsrc!\*.*
	!bat_echolog! call "!bat_exedir!\7za.exe" a -r -tzip "!bat_zipfile!" "!bat_zipsrc!"
	              call "!bat_exedir!\7za.exe" a -r -tzip "!bat_zipfile!" "!bat_zipsrc!"
	set bat_returncode=!errorlevel!
	if !bat_returncode! neq 0 (
		set bat_recent_error_msg=16.ERROR - Failed to create the zip file using: "!bat_exedir!\7za.exe" a -r -tzip "!bat_zipfile!" "!bat_zipsrc!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog! '    errorlevel=!bat_returncode!
		!bat_echolog!
	) else (
		set bat_recent_error_msg=16.SUCCESS - created "!bat_zipfile!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
	)
:SEVENZIP_END
!bat_echolog! return-:SEVENZIP [errorlevel=!bat_returncode! !bat_recent_error_msg!]
%bat_return%




	rem 17. Upload Zip via FTP ************************************
:UPLOADFTP
!bat_echolog! call :UPLOADFTP %*
	set bat_retval=failed
	if /i "!bat_submissionfilesdir!" equ "" (
		!bat_echolog!
		!bat_echolog!     Run Submission before zipping: 
		goto :UPLOADFTP_END
	)

	if /i "!bat_ftppassword!" equ "" (
		echo.
		echo.
		set bat_choice=
		set /P bat_choice=Enter your email address as the anonymous FTP password: 
		set bat_ftppassword=!bat_choice!
		call :SAVECONFIG
	)

	set bat_ftpfile=ftp.temp.txt

	set bat_zipfile=
	set bat_zip=
	!bat_echolog! '    for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`^) do ...
	for                    /f "usebackq tokens=*" %%a in  (`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`) do (
		set bat_zipfile=!bat_targetlocation!\CAMS\Submitted\%%~a
		set bat_zip=%%~a
	)
	
	if not defined bat_zipfile (
		set bat_recent_error_msg=17.ERROR - no matching zip file found.
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :UPLOADFTP_END
	) else (
		set bat_recent_error_msg=17.FOUND zip file - "!bat_zip!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '     17.FOUND zip file - "!bat_zip!"
		!bat_echolog!
		!bat_echolog!
	)
	
	call :FTPTRANSFER
	
:UPLOADFTP_END
!bat_echolog! return-:UPLOADFTP [!bat_retval!, "!bat_zipfile!" !bat_recent_error_msg!]
	if not defined autonomous (pause)
%bat_return%







	rem 17. Upload Zip via FTP ************************************
:UPLOADFTPAUTO
!bat_echolog! call :UPLOADFTPAUTO %*
	set bat_retval=failed
		if /i "!bat_submissionfilesdir!" equ "" (
		!bat_echolog!
		!bat_echolog!     Run Submission before zipping: 
		if not defined bat_autonomous (
			pause 
			goto :UPLOADFTPAUTO_END
		)
	)

	rem This is a one-time prompt. The password will be recorded into AutoCams.bat.ini
	rem and the question won't be asked again.
	if /i "!bat_ftppassword!" equ "" (
		echo.
		echo.
		set bat_choice=
		set /P bat_choice=Enter your email address as the anonymous FTP password: 
		set bat_ftppassword=!bat_choice!
		call :SAVECONFIG
	)

	set bat_ftpfile=ftp.temp.txt
	
	set bat_zipfile=
	set bat_zip=
	!bat_echolog! '    for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`^) do ...
	for                    /f "usebackq tokens=*" %%a in  (`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`) do (
		set bat_zipfile=!bat_targetlocation!\CAMS\Submitted\%%~a
		set bat_zip=%%~a
	)

	if not defined bat_zipfile (
		set bat_recent_error_msg=17.ERROR - no matching zip file found.
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '     !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :UPLOADFTP_END
	) else (
		set bat_recent_error_msg=17.FOUND zip file - "!bat_zip!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '     17.FOUND zip file - "!bat_zip!"
		!bat_echolog!
		!bat_echolog!
	)

	call :FTPTRANSFER
	

:UPLOADFTPAUTO_END
!bat_echolog! return-:UPLOADFTPAUTO [!bat_retval!, "!bat_zipfile!" !bat_recent_error_msg!]
%bat_return%





	rem Do an MD5 hash of the zip file for comparison
:FTPHASH
!bat_echolog call :FTPHASH %*
	set bat_retval=
	for /f "usebackq tokens=1" %%a in (`call md5 "%~1"`) do (
		set bat_retval=%%~a
	)

:FTPHASH_END
!bat_echolog! return-:FTPHASH [bat_hash=!bat_retval!]
!bat_return!




:FTPTRANSFER
!bat_echolog! call :FTPTRANSFER
	set bat_retval=failed
	if not exist "!bat_exedir!\Temp!" (
		md "!bat_exedir!\Temp!"
	)

	call :FTP_TESTZIP "!bat_zipfile!"
	if /i "!bat_returncode!" neq "0" goto :FTPTRANSFER_END

	echo user !bat_ftpuser!>"!bat_ftpfile!"
	echo !bat_ftppassword!>>"!bat_ftpfile!"
	echo bin>>"!bat_ftpfile!"
	echo cd !bat_ftpdir!>>"!bat_ftpfile!"
	echo put "!bat_zipfile!">>"!bat_ftpfile!"
	echo lcd "!bat_exedir!\Temp!">>!bat_ftpfile!"
	echo get "!bat_zip!">>!bat_ftpfile!"
	echo quit>>"!bat_ftpfile!"

	!bat_echolog! '    type "!bat_ftpfile!"......................
	                   type "!bat_ftpfile!"
	                   type "!bat_ftpfile!">>"!bat_logfile!"
	!bat_echolog! '..............................................
	!bat_echolog!

	!bat_echolog! '    call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!
					   call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!
	set bat_returncode=!errorlevel!
	!bat_echolog!
	!bat_echolog! '    FTP exit code=!bat_returncode!
	!bat_echolog!

::CHECK_GET
	if not exist "!bat_exedir!\Temp\!bat_zip!" (
		set bat_recent_error_msg=17.ERROR - Failed FTP upload of "!bat_zipfile!" - can't find it in "!bat_exedir!\Temp".
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
		goto :FTPTRANSFER_END
	) else (
		call :FTPHASH "!bat_zipfile!"
		set bat_hash_before=!bat_retval!
		
		call :FTPHASH "!bat_exedir!\Temp\!bat_zip!"
		set bat_hash_after=!bat_retval!
		
		if /i "!bat_hash_after!" neq "!bat_hash_before!" (
			set bat_recent_error_msg=17.FAILED - target is different from the source. Something went wrong between uploading the file and downloading it again to check.  The file exists on the FTP server, but when it is downloaded from the FTP server it is different from the original.
			!bat_echolog!
			!bat_echolog!
			!bat_echolog! '    !bat_recent_error_msg!
			!bat_echolog!
			!bat_echolog!
		)
		
		!bat_echolog! '    del /q "!bat_exedir!\Temp\!bat_zip!"
		                   del /q "!bat_exedir!\Temp\!bat_zip!"

		call :MOVETRANSMIT

		if /i "!bat_hash_after!" neq "!bat_hash_before!" (
			goto :FTPTRANSFER_END
		)

		!bat_echolog!
		!bat_echolog! copy /y "!bat_logfile!" "!bat_archivedfilesdir!\AutoCams2.bat.log"
					  copy /y "!bat_logfile!" "!bat_archivedfilesdir!\AutoCams2.bat.log"

		set bat_retval=success
		set bat_recent_error_msg=17.SUCCESS - FTP upload of "!bat_zipfile!"
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		!bat_echolog!
	)

:FTPTRANSFER_END
!bat_echolog! return-:FTPTRANSFER [!bat_retval!, !bat_recent_error_msg!]
%bat_return%




	rem Move to Transmitted
:MOVETRANSMIT
!bat_echolog! call :MOVETRANSMIT %*
	!bat_echolog! '    move /y "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" "!bat_targetlocation!\CAMS\Transmitted"
	                   move /y "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" "!bat_targetlocation!\CAMS\Transmitted"

:MOVETRANSMIT_END
!bat_echolog! return-:MOVETRANSMIT ["!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip"]
!bat_return!




:FTP_TESTZIP [in] "!bat_zipfile!"
!bat_echolog! call :FTP_TESTZIP %*

	if not exist "%~1" (
		set bat_returncode=98
		set bat_recent_error_msg=17.ERROR - Not found: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		goto :FTP_TESTZIP_END
	)

	call :FTPHASH "%~1"
	if /i "!bat_retval!" equ "76CDB2BAD9582D23C1F6F4D868218D6C" (
		set bat_returncode=99
		set bat_recent_error_msg=17.ERROR - Empty zip file: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		goto :FTP_TESTZIP_END
	)
	
	!bat_echolog! '    del /s /q "!bat_exedir!\Temp\Junk"
	                   del /s /q "!bat_exedir!\Temp\Junk"
	!bat_echolog! '    rd /s /q "!bat_exedir!\Temp\Junk"
	                   rd /s /q "!bat_exedir!\Temp\Junk"

	rem Unzip the file to "..\Temp\Junk" and check for errorlevel
	!bat_echolog! '    call "!bat_exedir!\7za.exe" x -y -r -tzip -o"!bat_exedir!\Temp\junk" "%~1" "*.*"
	                   call "!bat_exedir!\7za.exe" x -y -r -tzip -o"!bat_exedir!\Temp\junk" "%~1" "*.*"
	set bat_returncode=!errorlevel!
	
	rem Cleanup first
	!bat_echolog! '    del /s /q "!bat_exedir!\Temp\Junk"
	                   del /s /q "!bat_exedir!\Temp\Junk"
	!bat_echolog! '    rd /s /q "!bat_exedir!\Temp\Junk"
	                   rd /s /q "!bat_exedir!\Temp\Junk"

	if /i !bat_returncode! neq 0 (
		set bat_recent_error_msg=17.ZIP_CORRUPT - Corrupt zip file: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
		goto :FTP_TESTZIP_END
	) else (
		set bat_recent_error_msg=17.ZIP_OK - Zip file is OK: "%~1"
		!bat_echolog!
		!bat_echolog! '    !bat_recent_error_msg!
		!bat_echolog!
	)

:FTP_TESTZIP_END
!bat_echolog! return-:FTP_TESTZIP [!bat_returncode!, %~1]
!bat_return!









	rem 18. Email notice ******************************************
:EMAILTEXT
	set bat_tempdir=!bat_captureddate!_!bat_camera!
	
	echo.
	echo Email the following text to your central coordinator:
	echo.
	echo     Subject: CAMS submission for Camera !bat_camera! for !bat_captureddate!
	echo.

	echo     The CAMS files for Camera !bat_camera! for Capture Date of !bat_captureddate! 
	echo     have been processed.  
	echo.
	echo     Please let me know if anything of significance was found using this data.
	echo.
	echo     Details for the submission follow...
	echo.
	echo     Scanning for zip files in ["!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip"]...
	set bat_zipfile=
	if exist "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip" (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`) do (
			set bat_zipfile=!bat_targetlocation!\CAMS\Transmitted\%%~a
		)
		
		if defined bat_zipfile (
			echo       The CAMS submission for camera !bat_camera! for !bat_captureddate! HAS been uploaded 
			echo       to the FTP server.  The file name is:
			echo          "!bat_zipfile!"
		)
	) else (
		if not defined bat_zipfile (
			echo       The CAMS submission for camera !bat_camera! for !bat_captureddate! HAS NOT been  
			echo       uploaded.  The file name should have been:
			echo          "!bat_targetlocation!\CAMS\Transmitted\!bat_captureddate!_!bat_camera!*.zip"

			echo.
			if exist "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" (
				echo       Scanning for zip files in ["!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip"]...
				set bat_zipfile2=
				for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" /a-d /b /od`) do (
					set bat_zipfile2="!bat_targetlocation!\CAMS\Submitted\%%~a"
				)
				if defined bat_zipfile2 (
					echo         The zip file was created here, but was not uploaded:
					echo            "!bat_zipfile2!"
				)
			)
		)
	)
	
	echo.
	echo.
	set bat_emailfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\EmailFiles
	for /f "usebackq tokens=*" %%h in (`dir "!bat_emailfilesdir!\!bat_camera!_arch*.txt" /b`) do (
		for /f "tokens=1-6 delims=.,=" %%i in ("!bat_emailfilesdir!\%%h") do (
			echo                     Archived    Confirmed
			echo     Meteor Count    %%j          %%l
		)
	)

	echo.
	for /f "usebackq tokens=*" %%h in (`dir "!bat_submissionfilesdir!\!bat_camera!\Cal\CAL!bat_camera!_*.txt" /b /od /a-d`) do (
		set bat_calfilename=!bat_submissionfilesdir!\!bat_camera!\Cal\%%h
	)

	for /f "usebackq tokens=1-9 delims==" %%h in (`type "!bat_submissionfilesdir!\!bat_camera!\Cal\CAL!bat_camera!_*.txt"`) do (
		set bat_found=0
		if "%%h" equ " Camera number            " (set bat_found=1)
		if "%%h" equ " Calibration date         " (set bat_found=1)
		if "%%h" equ " Calibration time (UT)    " (set bat_found=1)
		if "%%h" equ " Cal center Azim (deg)    " (set bat_found=1)
		if "%%h" equ " Cal center Elev (deg)    " (set bat_found=1)
		if "%%h" equ " Cam tilt wrt Horiz (deg) " (set bat_found=1)
		if "%%h" equ " Mean O-C " (set bat_found=1)
		if !bat_found! equ 1 (
			set bat_temp=%%~h                              
			set bat_temp=!bat_temp:~0,27!
			echo  !bat_temp! =%%i
		)
	)



	
::GETCALFILENSTARS	
	set /a bat_calfilestars=0
	for /f "usebackq tokens=1-3" %%h in (`find /i /c " " "!bat_calfilename!"`) do (
		set /a "bat_calfilestars=%%j-56"
	)
	echo   Cal stars used             = !bat_calfilestars!

::SHOWSKIPPEDFRAMES
	echo.
	for /f "usebackq tokens=*" %%h in (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					echo call !bat_exedir!\skippedFrames.bat "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%h"
						 call !bat_exedir!\skippedFrames.bat "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%h"
				)
			)
		)
	)
	pause
%bat_return%
goto :EOF


:GETCALFILEINFO
	call GetCalfileInfo.bat "!bat_calfilename!"
%bat_return%



:CHECKBINFILESIZE
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\CheckBinFileSize.bat "!bat_capturedfilesdir!"
	     call !bat_exedir!\CheckBinFileSize.bat "!bat_capturedfilesdir!"
	cd /d !bat_exedir!
	pause
%bat_return%






















rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
:UTILSMENU
	call :CLEARSCREEN
	color !bat_color!
	if not defined bat_captureddate (
		set bat_titlebar=CAMS MENU Vers !bat_vers!
	) else (
		set bat_titlebar=CAMS MENU Vers !bat_vers!  for Captured Date: !bat_captureddate!
	)
	rem TITLE !bat_titlebar!
	TITLE %~dpnx0 - CAMS UTILITY MENU

	echo  !bat_titlebar!
	echo.
	echo 31. Command Prompt                    [ !bat_exedir!^> ]
	echo 32. Check for bad FF*.bin files       [CheckBinFileSize.bat]
	echo 33.    Delete bad FF*.bin files       [CheckBinFileSize.cleanup.bat]
	echo 34. Check free disk space             [CheckFreeSpace.bat !bat_targetlocation:~0,2!]
	echo 35. List all drives                   [ListDrives.bat]
	echo 36. Validate Calibration files for "!bat_captureddate!" [ValidateCal.bat]
	echo 37. Meteor Count Working dirs         [MeteorCount.presubmission.bat ]
	echo 38. Meteor Count SubmissionFiles dirs [MeteorCount.submission.bat ]
	echo 39. Display CapturedFiles info        [GetFFDirectoryListing.bat]
	echo 40. Display 3 days' CapturedFiles     [GetCaptured.bat]
	echo 41. Display 3 days' ArchivedFiles     [GetArchived.bat]
	echo 42. CheckTwilight for "Captured Date" [CheckTwilight.bat]
	echo 43. Launch Capture Script             [LaunchCapture.bat]
	echo 44. Multi-tasked Meteor Scan          [MakeCaseListing.bat]
	echo 44b. Merge Multi-tasked Meteor Scan Files [MergeCaseFiles.bat]
	echo 45. Single-threaded Meteor Scan       [FTP_Reprocess.exe]
	echo 45b. Post MultiScan Processing        [PostMultiScanCalibration.bat]
	echo.
	echo 47. Calculate Day Of Week for "!bat_captureddate!"
	echo 48. Save Configuration                ["%~dpnx0.ini"]
	echo 49. Night Mode                        [!bat_color_on!]
	echo 50. List dates that need processing   [Working CapturedFiles dir]
	echo 51. List Unzipped Nights              [Not zipped]
	echo 52. List Untransmitted Zips           [Not transmitted]
	echo 53. Make Movie from ConfirmedFiles    [MovieFromDetect.bat]
	echo 54. Coincidence                       [Coincidence.bat "!bat_captureddate!"]
	echo.
	echo 55. CameraLiveViewer              59. FTP_AdjustFFtimestamp
	echo 56. FTP_SingleFFmovie             60. FTP_CalSummary
	echo 57. FTP_CameraMovies              61. MakeArchiveDateZip
	echo.58. FTP_Mosaic
	echo  M. Main Menu
	echo  Q. Quit
	echo                Last error msg: !bat_recent_error_msg!
	echo.

	set bat_choice=none
	set /P bat_choice=Enter choice: 
	echo.
	if /i "!bat_choice!" equ "q" goto :DONE
	call :READPARAMS
	
	if /i "!bat_choice!" equ "r" (
		CALL :RESET
	)
	if /i "!bat_choice!" equ "u" goto :UTILSMENU
	if /i "!bat_choice!" equ "30" goto :UTILSMENU
	
	if /i "!bat_choice!" equ "1"  call :CHOOSETARGETDRIVE&goto :MENU
	if /i "!bat_choice!" equ "2"  call :CHOOSECAMERA&goto :MENU
	if /i "!bat_choice!" equ "3"  call :CHOOSEDATE&goto :MENU
	if /i "!bat_choice!" equ "3s"  (
		set bat_choice=s
		call :CHOOSEDATESUB&goto :MENU
	)
	
	if /i "!bat_choice!" equ "4"  call :CHOOSECAP&goto :MENU
	if /i "!bat_choice!" equ "5"  call :SKIPPEDFRAMES&GOTO :MENU
	
	if /i "!bat_choice!" equ "6"  call :CHOOSEARCH&goto :MENU
	if /i "!bat_choice!" equ "7a"  call :CALUPDATE&goto :MENU
	if /i "!bat_choice!" equ "7b"  call :CALUPDATEAUTO&goto :MENU
	if /i "!bat_choice!" equ "7c"  call :CALUPDATEAUTOPROMPT&goto :MENU
	if /i "!bat_choice!" equ "7d"  call :CAL&goto :MENU
	if /i "!bat_choice!" equ "9"  call :APPLY&goto :MENU
	if /i "!bat_choice!" equ "10" call :CONFIRM&goto :MENU
	if /i "!bat_choice!" equ "11" call :EDITCOMMENTS&goto :MENU
	if /i "!bat_choice!" equ "12" call :APPLYCONFIRMED&goto :MENU
	if /i "!bat_choice!" equ "13" call :SUBMIT&goto :MENU
	if /i "!bat_choice!" equ "14" call :choosesubmission&goto :MENU
	if /i "!bat_choice!" equ "15" call :RESTORESUBMIT&goto :MENU
	if /i "!bat_choice!" equ "16" call :MAKEZIP&goto :MENU
	if /i "!bat_choice!" equ "17" call :UPLOADFTP&goto :MENU
	if /i "!bat_choice!" equ "18" call :EMAILTEXT&goto :MENU
	
	if /i "!bat_choice!" equ "q" goto :DONE
	if /i "!bat_choice!" equ "m" goto :MENU
	if /i "!bat_choice!" equ "none" (
		goto :MENU
	)
	
	if /i "!bat_choice!" equ "31" call :CMDPROMPT&goto :UTILSMENU
	if /i "!bat_choice!" equ "32" call :CHECKBINFILESIZE&goto :UTILSMENU
	if /i "!bat_choice!" equ "33" call :CHECKBINCLEANUP&goto :UTILSMENU
	if /i "!bat_choice!" equ "34" call :CHECKFREESPACE&goto :UTILSMENU
	if /i "!bat_choice!" equ "35" call :LISTDRIVES&goto :UTILSMENU
	if /i "!bat_choice!" equ "36" call :VALIDATECAL&goto :UTILSMENU
	if /i "!bat_choice!" equ "37" call :METEORCOUNTPRE&goto :UTILSMENU
	if /i "!bat_choice!" equ "38" call :METEORCOUNTSUB&goto :UTILSMENU
	if /i "!bat_choice!" equ "39" call :GETFFDIRLIST&goto :UTILSMENU
	if /i "!bat_choice!" equ "40" call :GETCAPTURED&goto :UTILSMENU
	if /i "!bat_choice!" equ "41" call :GETARCHIVED&goto :UTILSMENU
	if /i "!bat_choice!" equ "42" call :GETTWILIGHT&GOTO :UTILSMENU
	if /i "!bat_choice!" equ "43" call :LAUNCHCAPTURE&GOTO :UTILSMENU
	if /i "!bat_choice!" equ "44"  call :REPROCESSMULTI&goto :UTILSMENU
	if /i "!bat_choice!" equ "44b" call :MERGECASE&goto :UTILSMENU
	if /i "!bat_choice!" equ "45"  call :REPROCESS&goto :UTILSMENU
	if /i "!bat_choice!" equ "45b" call :POSTMULTI "!bat_captureddate!"&goto :UTILSMENU
	if /i "!bat_choice!" equ "47" call :DAYOFWEEK&goto :UTILSMENU
	if /i "!bat_choice!" equ "48" call :SAVECONFIG&goto :UTILSMENU
	if /i "!bat_choice!" equ "49" call :NIGHTMODE&goto :UTILSMENU
	if /i "!bat_choice!" equ "50" call :LISTFAILED&goto :UTILSMENU
	if /i "!bat_choice!" equ "51" call :LISTUNZIPPED&goto :UTILSMENU
	if /i "!bat_choice!" equ "52" call :LISTUNTRANSMITTED&goto :UTILSMENU
	if /i "!bat_choice!" equ "53" call :METEORMOVIES&goto :UTILSMENU
	if /i "!bat_choice!" equ "54" call :COINCIDENCE&goto :UTILSMENU

	if /i "!bat_choice!" equ "55" call :CAMERALIVEVIEWER&goto :UTILSMENU
	if /i "!bat_choice!" equ "56" call :SINGLEFFMOVIE&goto :UTILSMENU
	if /i "!bat_choice!" equ "57" call :CAMERAMOVIES&goto :UTILSMENU
	if /i "!bat_choice!" equ "58" call :MOSAIC&goto :UTILSMENU
	if /i "!bat_choice!" equ "59" call :ADJUSTFFTIMESTAMP&goto :UTILSMENU
	if /i "!bat_choice!" equ "60" call :CALSUMMARY&goto :UTILSMENU

	
	if /i "!bat_choice!" equ "61" call :MAKEARCHIVEDATEZIP&goto :UTILSMENU
	
	if /i "!bat_choice!" equ "?" set bat_&pause&goto :UTILSMENU

	rem Hidden extras
	if /i "!bat_choice!" equ "v"  call :VARIABLES&goto :UTILSMENU
	if /i "!bat_choice!" equ "a"  call :AUTO&goto :UTILSMENU
	if /i "!bat_choice!" equ "cls" cls&:goto :UTILSMENU
	if /i "!bat_choice!" equ "fa" call :FIXDETECTPATHS "!bat_archivedfilesdir!" !bat_detectfile!&goto :UTILSMENU
	if /i "!bat_choice!" equ "fc" call :FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfile!&goto :UTILSMENU
	if /i "!bat_choice!" equ "clearerror" call :CLEARERROR&goto :UTILSMENU
	if /i "!bat_choice!" equ "edit" call :EDITAUTOCAMS&goto :UTILSMENU

	echo.!bat_choice!|find /i "notepad "
	if %errorlevel% equ 0 (
		echo %cd%
		start "" !bat_choice!
	)

goto :UTILSMENU



	rem 31u. Command Prompt *****************************************
:CMDPROMPT
	cd /d !bat_targetlocation!
	echo start "CAMS prompt" /d "!bat_exedir!" /i "!windir!\system32\cmd.exe"
	     start "CAMS prompt" /d "!bat_exedir!" /i "!windir!\system32\cmd.exe"
	cd /d !bat_exedir!

%bat_return%


	rem 32. CheckBinFileSize **************************************
:CHECKBINFILESIZE
	echo call CheckBinFileSize.bat
	call CheckBinFileSize.bat
:CHECKBINFILESIZE_END
%bat_return%



	rem 33. CheckBinCleanUp **************************************
:CHECKBINCLEANUP
	echo Warning, this script can delete ff*.bin files! 
	set bat_choice=
	set /P bat_choice=Are you sure? Y/N 
	if "!bat_choice!" equ "" goto :CHECKBINCLEANUP_END
	if /i "bat_choice!" neq "y" goto :CHECKBINCLEANUP_END

	echo call CheckBinFileSize.cleanup.bat
	call CheckBinFileSize.cleanup.bat
:CHECKBINCLEANUP_END
%bat_return%



	rem 34. CheckFreeSpace *****************************************
:CHECKFREESPACE
	set bat_choice=
	set /P bat_choice=Enter drive [!bat_targetlocation:~0,2!]: 
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_targetdrive:~0,2!)
	set bat_choice=!bat_choice::=!
	set bat_choice=!bat_choice!:

	echo '    call "!bat_exedir!\CheckFreeSpace.bat" !bat_choice!
	          call "!bat_exedir!\CheckFreeSpace.bat" !bat_choice!
	pause
%bat_return%



	rem 35. ListDrives *********************************************
:LISTDRIVES
	echo call "!bat_exedir!\ListDrives.bat"
	     call "!bat_exedir!\ListDrives.bat"
	pause
%bat_return%



	rem 36. ValidateCal ********************************************
:VALIDATECAL
	set bat_temp=!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!

	set bat_targetfilespec=!bat_caldir!\CAL???_*.txt

	if defined bat_captureddate (
		set bat_targetfilespec=!bat_caldir!\CAL!bat_camera!_!bat_temp!*.txt
	)

	if defined bat_latestcal (
		echo.
		echo   Current CAL file information is:
		echo   bat_camera=!bat_camera!
		echo   bat_latestcal=!bat_latestcal!
		set bat_targetfilespec=!bat_caldir!\!bat_latestcal!
		shift
		shift
	)

	echo call "!bat_exedir!\ValidateCal.bat" /cal "!bat_targetfilespec!"
	     call "!bat_exedir!\ValidateCal.bat" /cal "!bat_targetfilespec!"

	pause
%bat_return%



	rem 37. Meteor Count Presubmission *****************************
:METEORCOUNTPRE
	cd /d !bat_targetlocation!\CAMS
	echo call "!bat_exedir!\MeteorCount.presubmission.bat"
		 call "!bat_exedir!\MeteorCount.presubmission.bat"
	cd /d !bat_exedir!
	
	pause
%bat_return%



	rem 38. Meteor Count Submission ********************************
:METEORCOUNTSUB
	set bat_tempdir=
	if defined bat_captureddate (
		set bat_tempdir=!bat_captureddate!
	)
	echo call "!bat_exedir!\MeteorCount.submission.bat" "!bat_tempdir!"
		 call "!bat_exedir!\MeteorCount.submission.bat" "!bat_tempdir!"
	pause
%bat_return%



	rem 39. GetFFDirectoryListing **********************************
:GETFFDIRLIST
	cd /d !bat_targetlocation!\CAMS
	echo call "!bat_exedir!\GetFFDirectoryListing.bat" !bat_dateinput!
	     call "!bat_exedir!\GetFFDirectoryListing.bat" !bat_dateinput!
	cd /d !bat_exedir!
	pause
%bat_return%



	rem 40. GetCaptured *******************************************
:GETARCHIVED
	cd /d !bat_targetlocation!\CAMS
	echo call "!bat_exedir!\GetArchived.bat" !bat_dateinput!
	     call "!bat_exedir!\GetArchived.bat" !bat_dateinput!
	cd /d !bat_exedir!
	pause
%bat_return%



	rem 41. GetArchived *******************************************
:GETCAPTURED
	cd /d !bat_targetlocation!\CAMS
	echo call "!bat_exedir!\GetCaptured.bat" !bat_dateinput!
	     call "!bat_exedir!\GetCaptured.bat" !bat_dateinput!
	cd /d !bat_exedir!
	pause
%bat_return%



	rem 42. CheckTwilight  *****************************************
:GETTWILIGHT
	rem get twilight for today or the CapturedFiles date
	set bat_twilightdate=
	if defined bat_captureddate (
		set bat_twilightdate=!bat_dateinput!
	)
	cd /d !bat_targetlocation!\CAMS
	echo call "!bat_exedir!\CheckTwilight.bat" !bat_twilightdate!
	     call "!bat_exedir!\CheckTwilight.bat" !bat_twilightdate!
	echo.
	cd /d !bat_exedir!
	pause
%bat_return%





	rem 43. LaunchCapture  *****************************************
:LAUNCHCAPTURE
	echo.
	echo WARNING - This routine will start the capture process and it will kill
	echo           any existing running capture instances.  If capture
	echo           has already happened for this date and/or if you don't want to
	echo           start it again, you may want to quit, otherwise continue.
	echo.
:LAUNCHCAPTURE2
	set /p bat_choice=[Q]uit now.  Otherwise, [C]ontinue: 
	if /i "!bat_choice!" equ "q" goto :LAUNCHCAPTURE_END
	if /i "!bat_choice!" neq "c" goto :LAUNCHCAPTURE2
	
	echo.
	echo Notice -  You have the option to run capture in autonomous mode. In 
	echo           autonomous mode, it will complete the capture, perform a
	echo           automatic Meteor Cal Update, Apply the Cal to the detect
	echo           file, run the submission script, create a zip file, and
	echo           upload the zip file to the ftp server.
	echo.
	echo           If you choose to not run in autonomous mode, it will only
	echo           run the capture and then stop.
	echo.
	set bat_choice=
	set bat_autonomous=
	set /p bat_choice=Do you want to run in autonomous mode [Y/N] or [Q]uit? 
	if /i "!bat_choice!" equ "q" goto :LAUNCHCAPTURE_END
	if /i "!bat_choice!" equ "y" (set bat_autonomous=autonomous)
	echo.

	if not defined bat_targetlocation (
		call :CHOOSETARGETDRIVE
	)
	
	if not defined bat_camera (
		call :CHOOSECAMERA
	)
	
	cd /d !bat_exedir!
	echo '    start "LaunchCapture !bat_camera! 1 !bat_targetlocation!\" LaunchCapture !bat_camera! 1 "!bat_targetlocation!\" !bat_autonomous!
	          start "LaunchCapture !bat_camera! 1 !bat_targetlocation!\" LaunchCapture !bat_camera! 1 "!bat_targetlocation!\" !bat_autonomous!
	cd /d !bat_exedir!
:LAUNCHCAPTURE_END
%bat_return%



	rem 44. Reprocess Milti-tasking **********************************************
:REPROCESSMULTI
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :REPROCESSMULTI_END
	)
	
	echo.
	echo WARNING - This routine will start the meteor scan.  It will 
	echo           delete the collection of "ftpdetectinfo.txt" like 
	echo           files that may have already been created in the 
	echo           ArchivedFiles directory from a previous run.  If 
	echo           you do NOT wish to delete and overwrite those files, 
	echo.
:REPROCESSMULTI2
	set bat_choice=
	set /p bat_choice=[Q]uit now, otherwise, [C]ontinue: 
	if /i "!bat_choice!" equ "q" goto :REPROCESSMULTI_END
	if /i "!bat_choice!" neq "c" goto :REPROCESSMULTI2
	
	echo.

	echo call "!bat_exedir!\makeCaseListing.bat" "!bat_capturedfilesdir!"
	     call "!bat_exedir!\makeCaseListing.bat" "!bat_capturedfilesdir!"
	pause
:REPROCESSMULTI_END
%bat_return%



	rem 44b. MergeCaseFiles ****************************************
:MERGECASE
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :MERGECASE_END
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		goto :MERGECASE_END
	)
	
	!bat_echolog! '    call "!bat_exedir!\MergeCaseFiles.bat" "!bat_archivedfilesdir!"
	                   call "!bat_exedir!\MergeCaseFiles.bat" "!bat_archivedfilesdir!"

	set bat_temp=!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddir!.txt
	if not exist "!bat_temp!" (
		set bat_temp=FTPdetectinfo.txt
	)
	
	rem Get latest cal file
	set bat_latestcal=
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\!bat_temp!"`) do (
		if not defined bat_latestcal ( set bat_latestcal=%%a )
	)


:MERGECASE_END
	if not defined bat_autonomous (pause)
%bat_return%



	rem 45. Reprocess Single **********************************************
:REPROCESS
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :REPROCESS_END
	)
	
	echo.
	echo WARNING - This routine will start the meteor scan.  It will 
	echo           delete the collection of "ftpdetectinfo.txt" like 
	echo           files that may have already been created in the 
	echo           ArchivedFiles directory from a previous run.  If 
	echo           you do NOT wish to delete and overwrite those files, 
	echo.
:REPROCESS2
	set bat_choice=
	set /p bat_choice=[Q]uit now, otherwise, [C]ontinue: 
	if /i "!bat_choice!" equ "q" goto :REPROCESS_END
	if /i "!bat_choice!" neq "c" goto :REPROCESS2
	
	echo.

	echo call "!bat_exedir!\FTP_Reprocess.exe" "!bat_capturedfilesdir!"
	     call "!bat_exedir!\FTP_Reprocess.exe" "!bat_capturedfilesdir!"
	pause
:REPROCESS_END
%bat_return%





	rem 45b. Post Multiscan ***************************************
:POSTMULTI [in] "!bat_captureddate!"
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set bat_choice=
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		if /i "!bat_choice!" equ "force" (goto :POSTMULTI2)
		goto :POSTMULTI_END
	)

:POSTMULTI2
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		goto :POSTMULTI_END
	)
	
	cd /d !bat_targetlocation!\CAMS
	echo start "!bat_exedir!\PostMultiScanCalibration.bat !bat_archivedfilesdir!" /i cmd /c ""!bat_exedir!\PostMultiScanCalibration.bat" "!bat_archivedfilesdir!""
	     start "!bat_exedir!\PostMultiScanCalibration.bat !bat_archivedfilesdir!" /i cmd /c ""!bat_exedir!\PostMultiScanCalibration.bat" "!bat_archivedfilesdir!""
	cd /d !bat_exedir!

	set bat_temp=!bat_archivedfilesdir:ArchivedFiles=SubmissionFiles\%~1!
	if exist "!bat_temp!" (
		set bat_hasrun_post=true

		set bat_submissionfilesdir=!bat_archivedfilesdir:ArchivedFiles=SubmissionFiles\%~1!
		call :SAVECONFIG
	) else (
		echo.
		echo WARNING - "!bat_temp!" does not exist
	)
	pause
:POSTMULTI_END
%bat_return%



	rem 47. DayOfWeek *********************************************
:DAYOFWEEK
	echo call DayOfWeek.bat !bat_capturedDate!
	call DayOfWeek.bat !bat_capturedDate!
	pause
%bat_return%



	rem 48. Save Configuration ************************************
:SAVECONFIG
!bat_log! call :SAVECONFIG %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini

	echo [CAMSMENU]>"!bat_configfile!"
	echo bat_targetlocation=!bat_targetlocation!>>"!bat_configfile!"
	echo bat_camera=!bat_camera!>>"!bat_configfile!"
	echo bat_captureddate=!bat_captureddate!>>"!bat_configfile!"
	echo bat_capturedfilesdir=!bat_capturedfilesdir!>>"!bat_configfile!"
	echo bat_archivedfilesdir=!bat_archivedfilesdir!>>"!bat_configfile!"
	echo bat_capturedcount=!bat_capturedcount!>>"!bat_configfile!"
	echo bat_archivedcount=!bat_archivedcount!>>"!bat_configfile!"
	echo bat_latestcal=!bat_latestcal!>>"!bat_configfile!"
	echo bat_submissionfilesdir=!bat_submissionfilesdir!>>"!bat_configfile!"
	echo bat_ftppassword=!bat_ftppassword!>>"!bat_configfile!"
	echo bat_ftpsite=!bat_ftpsite!>>"!bat_configfile!"
	echo bat_ftpuser=!bat_ftpuser!>>"!bat_configfile!"
	echo bat_ftpdir=!bat_ftpdir!>>"!bat_configfile!"
	echo bat_recent_error_msg=!bat_recent_error_msg!>>"!bat_configfile!"
:SAVECONFIG_END
!bat_log! return-:SAVECONFIG
%bat_return%





:READCONFIG
!bat_log! call :READCONFIG %*
	set bat_retval=failed
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini

	for /f "usebackq tokens=*" %%x in (`type "!bat_configfile!"`) do (
		set bat_retval=success
		rem echo set %%x
		if /i "%%x" neq "[CAMSMENU]" (
		     set %%x
		)
	)

	rem set bat_targetdrive=!bat_targetlocation:~0,2!
	set bat_targetdrive=!bat_targetlocation!
	
	call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount
	call :GETCONFIRMEDCOUNT
:READCONFIG_END
!bat_log! return-:READCONFIG [AutoCams.bat.ini=!bat_retval!, "!bat_capturedfilesdir!"]
%bat_return%


:READCONFIGVAR
rem !bat_echolog! call :READCONFIGVAR %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	set bat_tempvar=%~1

	for /f "usebackq tokens=* skip=2" %%x in (`find /i "!bat_tempvar!" "!bat_configfile!"`) do (
		rem echo set %%x
		if /i "%%x" neq "[CAMSMENU]" (
		     set %%x
		)
	)

	
rem !bat_echolog! return-:READCONFIGVAR [!bat_capturedfilesdir!]
%bat_return%



	rem 49. NIGHT MODE ************************************
:NIGHTMODE
	if not defined bat_color (
		set bat_color=47
		set bat_color_on=toggle off
	) else (
		set bat_color=
		set bat_color_on=toggle on
		color 07
	)
%return%



	rem 50. LIST FAILED processing **************************
:LISTFAILED
!bat_echo! call :LISTFAILED
	rem This routine lists the dates that still need to be processed.
	rem The list is derived from listing the CapturedFiles directory.
	rem Some other methods to determine if they failed processing are:
	rem   1. Their AutoCalUpdate.log file shows an error (but what if it
	rem      was manually calibrated?)
	rem   2. If the calibration file values are sub-par
	rem   3. If the most recent calibration file for the date
	rem      is not the one used in the detect file
	rem   4. If the CapturedFiles directory still exists in the 
	rem      working area instead of SubmissionFiles

	set bat_tempdir=!bat_targetlocation!\CAMS\CapturedFiles
	
	echo.
	echo     List of dates that haven't been packaged for SubmissionFiles 
	echo     ^(These are a list of dirs under "!bat_tempdir!"^)
	set /a bat_count=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_tempdir!" /b /ad /on`) do (
		set /a bat_count+=1
		echo     !bat_count!.	%%~nxa
	)
	echo.
	

:LISTFAILED_END
	pause
!bat_return!



	rem 51u. LIST Unzipped processing **************************
:LISTUNZIPPED
!bat_echo! call :LISTUNZIPPED %*
	rem This routine lists the dates that need to be zipped. 
	rem The list is derived as follows:
	rem   1) Check the SubmissionFiles directory.  For each date:
	rem      a) Check the Transmitted dir for a matching zip
	rem      b) Check the Submitted dir for a matching zip
	rem      c) Check the SubmissionFiles dir for any files newer
	rem         than the newest existing zip file in Transmitted
	rem      d) Check the SubmissionFiles dir for any files newer
	rem         than the newest existing zip in Submitted

	set bat_tempsubmissiondir=!bat_targetlocation!\CAMS\SubmissionFiles
	set bat_tempsubmitteddir=!bat_targetlocation!\CAMS\Submitted
	set bat_temptransmitteddir=!bat_targetlocation!\CAMS\Transmitted

	echo.
	echo     Report of unzipped submission dirs...
	echo     ^(Lists each dir in the SubmissionFiles dir that does not have a 
	echo     corresponding zip file with the same date_camera file name... ^)
	echo.
	set /a bat_count=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_tempsubmissiondir!" /b /ad /on`) do (
		set bat_temp_dirname=%%~nxa_!bat_camera!
		
		if not exist "!bat_temptransmitteddir!\!bat_temp_dirname!*.zip" (
			set /a bat_count+=1
			echo     !bat_count!.	!bat_tempsubmissiondir!\%%~nxa
		)
	)
	echo.
:LISTUNZIPPED_END
!bat_echo! return-:LISTUNZIPPED
	pause
!bat_return!



	rem 52u. LIST Untransmitted processing **************************
:LISTUNTRANSMITTED
	set bat_tempsubmissiondir=!bat_targetlocation!\CAMS\SubmissionFiles
	set bat_tempsubmitteddir=!bat_targetlocation!\CAMS\Submitted
	set bat_temptransmitteddir=!bat_targetlocation!\CAMS\Transmitted

	echo.
	echo     Report of untransmitted zip files...
	set /a bat_count=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_tempsubmissiondir!" /b /ad /on`) do (
		set bat_temp_dirname=%%~nxa_!bat_camera!
		
		if not exist "!bat_temptransmitteddir!\!bat_temp_dirname!*.zip" (
			set /a bat_count+=1
			echo     !bat_count!.	!bat_tempsubmissiondir!\%%~nxa
		)
	)
	echo.

:LISTUNTRANSMITTED_END
	pause
!bat_return!




	rem 53. FTP_MeteorMovies **************************
:METEORMOVIES
	set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	echo '    if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" 
	if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
		set bat_detectfile=FTPdetectinfo.txt
		if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
			echo '    ERROR - Can't find either: 
			echo '            !bat_confirmedfilesdir!\FTPdetectfinfo_0!bat_camera!_!bat_captureddate!.txt
			echo '       or   !bat_confirmedfilesdir!\FTPdetectinfo.txt
			goto :METEORMOVIES_END
		)
	)

	if exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
		!bat_echolog! '    call :FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfile!
						   call :FIXDETECTPATHS "!bat_confirmedfilesdir!" !bat_detectfile!

		!bat_echolog! '    call "!bat_exedir!\MovieFromDetect.bat" "!bat_confirmedfilesdir!\!bat_detectfile!"
						   call "!bat_exedir!\MovieFromDetect.bat" "!bat_confirmedfilesdir!\!bat_detectfile!"
	) else (
		echo '    ERROR - Can't find: "!bat_confirmedfilesdir!\!bat_detectfile!"
		goto :METEORMOVIES_END
	)

:METEORMOVIES_END
	pause
!bat_return!



	rem 54u. Coincidence ******************************************
:COINCIDENCE
	set bat_confirmdetect=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	if not exist "!bat_confirmedfilesdir!\!bat_confirmdetect!" (
		set bat_confirmdetect=FTPdetectinfo.txt
	)

:COINCIDENCE2
	

	echo.
	echo When asked to "Navigate to FTP Detection File to Process 
	echo for Coincidence", instead navigate to and select:
	echo   "!bat_archivedfilesdir!\!bat_confirmdetect!". 
	echo.
	echo call  "!bat_exedir!\Coincidence.bat" "!bat_captureddate!"
	     call  "!bat_exedir!\Coincidence.bat" "!bat_captureddate!"


:COINCIDENCE_END
%bat_return%



	rem 55u. CameraLiveViewer ****************************
:CAMERALIVEVIEWER
	echo call  "!bat_exedir!\CameraLiveViewer.exe"
	     call  "!bat_exedir!\CameraLiveViewer.exe"
:CAMERALIVEVIEWER_END
%bat_return%


	rem 56u. FTP_SingleFFmovie ****************************
:SINGLEFFMOVIE
	echo call  "!bat_exedir!\FTP_SingleFFmovie.exe"
	     call  "!bat_exedir!\FTP_SingleFFmovie.exe"
:SINGLEFFMOVIE_END
%bat_return%


	rem 57u. FTP_CameraMovies ****************************
:CAMERAMOVIES
	echo call  "!bat_exedir!\FTP_CameraMovies.exe"
	     call  "!bat_exedir!\FTP_CameraMovies.exe"
:CAMERAMOVIES_END
%bat_return%


	rem 58u. FTP_Mosaic ****************************
:MOSAIC
	echo call  "!bat_exedir!\FTP_Mosaic.exe"
	     call  "!bat_exedir!\FTP_Mosaic.exe"
:MOSAIC_END
%bat_return%


	rem 59u. FTP_AdjustFFtimestamp ****************************
:ADJUSTFFTIMESTAMP
	echo call  "!bat_exedir!\FTP_AdjustFFtimestamp.exe"
	     call  "!bat_exedir!\FTP_AdjustFFtimestamp.exe"
:ADJUSTFFTIMESTAMP_END
%bat_return%


	rem 60u. FTP_CalSummary ****************************
:CALSUMMARY
	echo call  "!bat_exedir!\FTP_CalSummary.exe"
	     call  "!bat_exedir!\FTP_CalSummary.exe"
:CALSUMMARY_END
%bat_return%


	rem 61u. MakeArchiveDateZip.bat ****************************
:MAKEARCHIVEDATEZIP
	echo.
	echo.
	echo Do you want to zip one directory or the entire selected month? 
	echo [O]ne date
	echo [M]onth
	echo [Q]uit
	set /p bat_choice="  "
	if /i "!bat_choice!" equ "q" (goto :MAKEARCHIVEDATEZIP_END)
	if /i "!bat_choice!" equ "o" (
				!bat_echolog! '    call "!bat_exedir!\zipdir_7za.bat" "!bat_startlocation!\SubmissionFiles\!bat_captureddate!"
				                   call "!bat_exedir!\zipdir_7za.bat" "!bat_startlocation!\SubmissionFiles\!bat_captureddate!"
	) 
	
	if /i "!bat_choice!" equ "m" (
		!bat_echolog! '    for /f "usebackq tokens=*" ..a in ^(`dir "!bat_startlocation!\SubmissionFiles\!bat_captureddate:~0,8!??" /b /ad /on`^) do ^(
		for                    /f "usebackq tokens=*" %%a in  (`dir "!bat_startlocation!\SubmissionFiles\!bat_captureddate:~0,8!??" /b /ad /on`) do (
			!bat_echolog! '    call "!bat_exedir!\zipdir_7za.bat" "!bat_startlocation!\SubmissionFiles\%%a"
							   call "!bat_exedir!\zipdir_7za.bat" "!bat_startlocation!\SubmissionFiles\%%a"
		)
	)
	
:MAKEARCHIVEDATEZIP_END
%bat_return%







:VARIABLES
	set bat_
	pause
%return%


:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_echolog! call :FIXDETECTPATHS [%*, !bat_detectfile!]
	set bat_retval=0

if defined bat_commentedsection (
 	if /i "!bat_submissionfilesdir!" neq "" (
 		echo.
 		set /p bat_choice=NOT SUPPORTED - You you have already run Submission. 
 		goto :FIXDETECTPATHS_END
	)
)& rem if defined bat_commentedsection

	!bat_echolog! '    call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	                   call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	set bat_retval=!errorlevel!
	if !bat_retval! neq 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	) else (
		set bat_recent_error_msg=SUCCESS - FixDetectPaths.bat "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
	)
:FIXDETECTPATHS_END
!bat_echolog! return-:FIXDETECTPATHS [!bat_recent_error_msg!]
!bat_return!


:EDITAUTOCAMS
	!bat_echoonly! :EDITAUTOCAMS
	!bat_echoonly! start notepad autocams.bat
	               start notepad autocams.bat
!bat_return!





	rem This reads the "AutoCams.Params.ini" file for 
	rem sections, keys, and values.  The keys and values
	rem are in the format of autonomouslevel=cal.  
	rem 
	rem If the environment variable is not a [section] then it
	rem is either a key or a comment.  
	rem 
	rem A comment is any line that starts with "//" or "rem ". 
	rem 
	rem If the key starts with "bat_", then the environment variable
	rem will bet set without the section prefix.  Otherwise, the
	rem environment variable will be set with the section 
	rem prefix.
	rem
	rem Examples:
	rem  [AUTOCAMS]
	rem  autonomouslevel=apply
	rem
	rem This would result in the following command being executed:
	rem set AUTOCAMS.autonomouslevel=apply
	rem
	rem  [CALIBRATION]
	rem  bat_calnstars=80
	rem
	rem This would result in the following command being executed:
	rem set bat_calnstars=80
	rem
	rem The reason for the different treatment is to make the ini file
	rem compatible with some script variables that were in use before
	rem the AutoCams system was expanded to using this AutoCams.Params.ini 
	rem file. 
	rem
	rem Place this section of code into:
	rem		AutoCams.bat
	rem  	StageFromConfirmed.bat
	rem 	ValidateCal.bat
	rem
:READPARAMS
!bat_log! call "!bat_exedir!\ReadParams.bat"
	      CALL "!bat_exedir!\ReadParams.bat"
:READPARAMS_END
!bat_log! return-:READPARAMS [!bat_paramsfile!=!bat_retval!]
%bat_return%



		[COINCIDENCE]
		max.height=249
		min.height=40

		[CALIBRATION]
		bat_calnstars=80
		bat_caloc=2.50

		[AUTOCAMS]
		//              cal
		autonomouslevel=apply
		//              applyconfirmed
		//              submit
		//              zip
		//              ftp
		validatewait=15
		completewait=60







:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%


:ECHOONLY
	rem Echo to the console
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%
%bat_return%








:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0
	echo.
	echo Displays the CAMS menu system to facilitate access to batch scripts
	echo and processing
	echo.
	echo For autonomous mode, use the following command line options:
	echo.
	echo        %~nx0 ^<"capturedfilesdir"^> ^<"archivedfilesdir"^> ^<camera^> autonomous
	echo.
	echo Example:
	echo    %~nx0 "C:\CAMS\CapturedFiles\2011_12_25_01_33_46" "C:\CAMS\ArchivedFiles\2011_12_25_01_35_05" 299 autonomous
	echo.
exit /b 9

Needs:
	- merge all captures for a single date
	- merge all archived for a single date (harder to do)
	- skippedFrames monitoring
	- convert all batch scripts to be able to run at the same time
	
	- Add AutoCams.Params.ini file
	- 
	- StageFromConfirmed.bat - Fix where it always says that it failed.
	Coincidence - increase the ceiling from 140km to max allowable by military
	- Coincidence - use gefdat data to determine which ff files to upload 
      based on the date  time of events 
        see CoincidentMeteorLog.txt for 
           camera, site code, D-Time, Conv, RA, DEC, Drad, Hbeg, Hend, AzimN, Elev
        see SummaryMeteorLog.txt for where "inf" is radiant info:
           Date, TimeUT, TbegSec, TendSec, RAinf, DECinf, Vinf, Acc1, Acc2, 
           LatBeg, LonBeg, Hbeg, LatEnd, LonEnd, Hend, 
           Conv, S-Azim, ZenAng, Hmax, Max-mV, Int-mV, F-skew, Cameras
        see CAMS_nnnnn.cc.txt for (where "cc" is the station code):
           Line 1: Station Name, Station Code, CoincidenceNumber 
           Line 2: FF file name
           Line 3: CAL file name
           Line 4: Site's GPS coords, for example, site 213 in brentwood:
                   Lat= 37 56 53.196  Long= 238 16 30.288  Alt= 26.0  fps= 29.970
           Line 4: YYYY-MM-DD HH:MM:SS.sss  at Peak Frame 174
           Line 5: ----------------------------
           Line 6: Header
           Line 7: ----------------------------
           Remaining lines in the following format:
              Frame  Time(UT)      Range   Height  Vel      IntenR  mV-Vmag  mV-Flux  Lat       Long      AzimS   ZenAng 
			  -----------------------------------------------------------------------------------------------------------
			  164.5  07:11:28.474  094.60  082.16  017.468  001760  0001.57  0001.74  038.1750  -122.1720  122.84  029.95
			  165.0  07:11:28.491  094.50  081.97  017.468  002409  0001.12  0001.28  038.1773  -122.1721  123.08  030.08
			  165.5  07:11:28.508  094.42  081.83  017.468  002852  0000.86  0001.03  038.1792  -122.1716  123.34  030.17
			  166.0  07:11:28.524  094.31  081.63  017.467  002560  0001.05  0001.22  038.1817  -122.1714  123.62  030.30
			  166.5  07:11:28.541  094.23  081.46  017.467  002240  0001.28  0001.44  038.1836  -122.1714  123.84  030.41
			  167.0  07:11:28.558  094.14  081.30  017.466  001988  0001.47  0001.64  038.1857  -122.1709  124.11  030.52
			  167.5  07:11:28.574  094.05  081.15  017.466  002528  0001.12  0001.28  038.1878  -122.1705  124.37  030.61
			  168.0  07:11:28.591  093.96  080.97  017.465  002724  0001.01  0001.18  038.1901  -122.1702  124.64  030.73
			  168.5  07:11:28.608  093.86  080.79  017.464  002600  0001.10  0001.27  038.1924  -122.1699  124.92  030.85
			  169.0  07:11:28.625  093.78  080.62  017.464  002528  0001.16  0001.33  038.1944  -122.1697  125.15  030.97
			  169.5  07:11:28.641  093.71  080.48  017.463  002636  0001.11  0001.27  038.1963  -122.1693  125.37  031.06
			  170.0  07:11:28.658  093.61  080.27  017.461  002525  0001.19  0001.36  038.1988  -122.1692  125.66  031.20
			  170.5  07:11:28.675  093.53  080.12  017.460  002669  0001.12  0001.28  038.2007  -122.1689  125.88  031.31
			  171.0  07:11:28.691  093.45  079.96  017.458  002836  0001.03  0001.19  038.2028  -122.1686  126.14  031.42
			  171.5  07:11:28.708  093.37  079.78  017.457  002773  0001.08  0001.24  038.2050  -122.1684  126.38  031.55
			  172.0  07:11:28.725  093.29  079.62  017.454  002505  0001.26  0001.42  038.2071  -122.1681  126.61  031.66
			  172.5  07:11:28.741  093.20  079.45  017.452  002696  0001.15  0001.32  038.2095  -122.1673  126.91  031.76
			  173.0  07:11:28.758  093.12  079.28  017.449  002804  0001.10  0001.26  038.2115  -122.1674  127.11  031.89
			  173.5  07:11:28.775  093.05  079.13  017.446  003081  0000.95  0001.12  038.2135  -122.1670  127.35  032.00
			  174.0  07:11:28.791  092.97  078.97  017.442  003295  0000.85  0001.01  038.2156  -122.1666  127.60  032.11
			  174.5  07:11:28.808  092.90  078.81  017.437  002923  0001.07  0001.23  038.2176  -122.1664  127.80  032.23
			  175.0  07:11:28.825  092.82  078.63  017.432  003194  0000.93  0001.09  038.2197  -122.1663  128.05  032.36
			  175.5  07:11:28.841  092.75  078.45  017.426  002923  0001.09  0001.25  038.2219  -122.1661  128.27  032.49
			  176.0  07:11:28.858  092.67  078.29  017.419  002968  0001.08  0001.24  038.2241  -122.1657  128.53  032.61
			  176.5  07:11:28.875  092.60  078.12  017.411  002994  0001.07  0001.24  038.2262  -122.1653  128.77  032.73
			  177.0  07:11:28.891  092.53  077.96  017.401  002745  0001.23  0001.39  038.2282  -122.1652  128.97  032.85
			  177.5  07:11:28.908  092.46  077.80  017.390  002446  0001.43  0001.59  038.2304  -122.1646  129.21  032.96
			  178.0  07:11:28.925  092.39  077.63  017.378  002278  0001.55  0001.72  038.2326  -122.1645  129.45  033.09
			  178.5  07:11:28.942  092.33  077.48  017.363  002497  0001.42  0001.58  038.2345  -122.1641  129.66  033.20
			  179.0  07:11:28.958  092.26  077.30  017.345  002611  0001.35  0001.52  038.2366  -122.1641  129.87  033.34
			  179.5  07:11:28.975  092.19  077.15  017.325  002198  0001.64  0001.80  038.2385  -122.1639  130.08  033.46
			  180.0  07:11:28.992  092.13  076.99  017.302  001966  0001.82  0001.98  038.2406  -122.1634  130.30  033.57
			  180.5  07:11:29.008  092.06  076.81  017.275  001693  0002.05  0002.21  038.2429  -122.1631  130.54  033.71
			  181.0  07:11:29.025  092.00  076.67  017.244  001699  0002.05  0002.22  038.2448  -122.1627  130.75  033.82
			  181.5  07:11:29.042  091.93  076.48  017.207  001724  0002.04  0002.21  038.2471  -122.1626  130.99  033.97
			  182.0  07:11:29.058  091.87  076.32  017.165  001762  0002.02  0002.18  038.2492  -122.1622  131.20  034.08
			  182.5  07:11:29.075  091.81  076.16  017.116  001583  0002.18  0002.35  038.2512  -122.1620  131.41  034.21
			  183.0  07:11:29.092  091.75  076.01  017.059  001351  0002.41  0002.58  038.2532  -122.1617  131.61  034.33
			  183.5  07:11:29.108  091.69  075.85  016.992  001320  0002.45  0002.62  038.2552  -122.1615  131.82  034.45
			  184.0  07:11:29.125  091.64  075.68  016.915  001527  0002.26  0002.42  038.2572  -122.1613  132.01  034.58
			  184.5  07:11:29.142  091.58  075.53  016.826  001435  0002.35  0002.52  038.2591  -122.1610  132.21  034.70
			  185.0  07:11:29.158  091.52  075.37  016.722  001228  0002.58  0002.74  038.2613  -122.1607  132.42  034.83
			  185.5  07:11:29.175  091.47  075.19  016.601  000901  0002.99  0003.15  038.2634  -122.1606  132.62  034.97
			  186.0  07:11:29.192  091.42  075.06  016.461  000977  0002.89  0003.06  038.2652  -122.1601  132.82  035.07
			  186.5  07:11:29.208  091.36  074.89  016.299  000619  0003.47  0003.64  038.2674  -122.1596  133.04  035.21
			  187.0  07:11:29.225  091.32  074.76  016.110  000633  0003.45  0003.62  038.2688  -122.1598  133.16  035.31
			  187.5  07:11:29.242  091.26  074.58  015.891  000747  0003.26  0003.42  038.2713  -122.1593  133.41  035.46
			  188.0  07:11:29.259  091.21  074.42  015.636  001841  0002.05  0002.21  038.2732  -122.1591  133.59  035.59
			  188.5  07:11:29.275  091.16  074.27  015.341  001638  0002.23  0002.39  038.2752  -122.1588  133.79  035.71
			  189.0  07:11:29.292  091.12  074.13  014.998  001775  0002.12  0002.28  038.2771  -122.1586  133.97  035.83
			  189.5  07:11:29.309  091.07  073.98  014.599  001902  0002.02  0002.18  038.2790  -122.1581  134.16  035.94
			  190.0  07:11:29.325  091.03  073.84  014.136  001746  0002.15  0002.32  038.2807  -122.1580  134.32  036.06


	- 


:DONE
	call :SAVECONFIG
	echo.
	echo Done with %0 %*
	echo.
