  @echo off
setlocal enabledelayedexpansion enableextensions
rem


:CHECKHELP
	set bat_vers=0.900

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:

	New changes 04/28/2012:
		
	
	
:SETUP
	set return=goto :EOF
	set bat_return=goto :EOF
	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_LOG=call :LOG
	set BAT_ECHO=call :ECHOONLY

	set bat_exedir=%~dp0::&					rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	set bat_exedrive=!bat_exedir:~0,2!&			rem f:
	
	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	set bat_logfile=!bat_startlocation!\AutoCams.bat.log
	
	
	%bat_echolog% =============================================================
	%bat_echolog% %date% %time% - %~dpnx0 %*
	
	set bat_returncode=0


	call :PARSEARGS %*
	if !bat_returncode! neq 0 goto :HELP

goto :MAIN

	
:PARSEARGS
!bat_echolog! call :PARSEARGS %*
	set bat_returncode=0

	if /i "%~1" equ "" (
		set bat_returncode=1
		echo     You must specify a source directory
	)

	set bat_confirmedfilesdir=%~dp1::
	set bat_confirmedfilesdir=!bat_confirmedfilesdir:\::=!
	set bat_confirmedfilesdir=!bat_confirmedfilesdir:::=!
	
	set bat_confirmedmoviesdir=!bat_confirmedfilesdir!\movies
!bat_echolog! return-:PARSEARGS [returncode=!bat_returncode!, "!bat_confirmedfilesdir!"]
%return%



REM ======================= MAIN ===================================

:MAIN
	if exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
		rem Sort by date and get the newest one
		echo '    for /f "usebackq tokens=*" %a in ^(`find /i ".bin" "!bat_confirmedfilesdir!\!bat_detectfile!"`^) do ^(
		for           /f "usebackq tokens=*" %%a in (`find /i ".bin" "!bat_confirmedfilesdir!\!bat_detectfile!"`) do (
			set bat_fffile=%%a
			set bat_fffile2=%%~nxa
			set bat_fffilefull=!bat_confirmedfilesdir!\%%~a
		)
		
		echo !bat_detectfile!, !bat_detectfile2!

		echo '    start /w "!bat_exedir!\FTP_SingleFFMovie.exe 29.97  !bat_fffilefull!"
				  start /w "!bat_exedir!\FTP_SingleFFMovie.exe 29.97  !bat_fffilefull!"

		echo.

	) else (
		echo '    ERROR - Can't find: "!bat_confirmedfilesdir!\!bat_detectfile!"
	)
	
	if exist "!bat_confirmedmoviesdir!\*.avi" (
		echo '    call "!bat_exedir!\7zip.bat" "!bat_confirmedfilesdir!\!bat_captureddate!.avi.zip" "!bat_confirmedfilesdir!\*.avi!"
				  call "!bat_exedir!\7zip.bat" "!bat_confirmedfilesdir!\!bat_captureddate!.avi.zip" "!bat_confirmedfilesdir!\*.avi!"
		echo.
		echo '    del /q "!bat_confirmedfilesdir!\*.avi"
				  del /q "!bat_confirmedfilesdir!\*.avi"
	)
goto :DONE






:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%


:ECHOONLY
	rem Echo to the console
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%
%bat_return%








:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "^<source dir^>"
	echo.
	echo Produces an AVI file based on the specified FF file. 
	echo.
	echo The output is saved in the source directory.
	echo.
	echo.
exit /b 9


:DONE
	echo.
	echo Done with %0 %*
	echo.
